/*jshint esversion: 6 */
	import * as THREE from 'three';
	import {FontLoader} from 'three/addons/loaders/FontLoader.js';
	import {TextGeometry} from 'three/addons/geometries/TextGeometry.js';

	// gun rack
	export function gun(param) {
		const width=800, height=2000, depth=800;
		const gunObject = new THREE.Object3D();
		const gunmaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		const gungeometry = new THREE.BoxGeometry(width, height, depth);
		const gunmesh = new THREE.Mesh(gungeometry, gunmaterial);
		gunObject.add(gunmesh);
		return gunObject;
	}

	// quadrupole booster
	export function quadrupolebooster(param) {
		const length = param && typeof param.length == "number"? param.length: 200;
		const QuadrupolContiner = new THREE.Object3D();
		const QuadrupoleMaster = new THREE.Object3D();
		
		const dmaterial = new THREE.MeshLambertMaterial({color: 0xe05040, side: THREE.DoubleSide});
		const d1geometry = new THREE.CylinderGeometry(500, 500, length, 4 /*radialSegments*/, 2 /*heightSegments*/, true /*openEnded*/,0 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		const d1mesh = new THREE.Mesh(d1geometry, dmaterial);
		d1mesh.position.set(0, 0, 0);
		d1mesh.rotateX(Math.PI * 1.25);
		d1mesh.rotateY(Math.PI * 1);
		d1mesh.rotateZ(Math.PI * 1.5);	
		QuadrupoleMaster.add(d1mesh);	
		
		// coil settings
		const coilmaterial = new THREE.MeshLambertMaterial({color: 0xcd7f32, side: THREE.DoubleSide});
		const textureLoader = new THREE.TextureLoader();
		const texture = textureLoader.load('./components/coil_texture.png');
		texture.wrapS = texture.wrapT = THREE.RepeatWrapping;
		texture.repeat.set(5, 5);
		const coiltexture = new THREE.MeshBasicMaterial({ map: texture });
		const coilmaterials = [coiltexture, coilmaterial, coilmaterial];
		const coilgeometry = new THREE.CylinderGeometry(110 /*radiusTop*/, 110 /*radiusBottom*/, 120 /*height*/, 25 /*radialSegments*/, 4 /*heightSegments*/, false /*openEnded*/,Math.PI * 1.5 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		
		//spessore alto
		const redmaterial = new THREE.MeshLambertMaterial({color: 0xe05040});
		const geometry_1 = new THREE.BoxGeometry(200, 100, 705);
		const dmesh_1 = new THREE.Mesh(geometry_1, redmaterial);
		dmesh_1.position.set(0, 300, 0);
		QuadrupoleMaster.add(dmesh_1);
		
		//spessore basso
		const dmesh_2 = new THREE.Mesh(geometry_1, redmaterial);
		dmesh_2.position.set(0, -300, 0);
		QuadrupoleMaster.add(dmesh_2);
		
		//spessore destro
		const geometry_3 = new THREE.BoxGeometry(200, 500, 100);
		const dmesh_3 = new THREE.Mesh(geometry_3, redmaterial);
		dmesh_3.position.set(0, 0, -300);
		QuadrupoleMaster.add(dmesh_3);	
		
		//spessore sinistro
		const dmesh_4 = new THREE.Mesh(geometry_3, redmaterial);
		dmesh_4.position.set(0, 0, 300);
		QuadrupoleMaster.add(dmesh_4);			

		const geometry_5 = new THREE.BoxGeometry(200, 115, 280);
		const dmesh_5 = new THREE.Mesh(geometry_5, redmaterial);
		dmesh_5.rotateX(Math.PI * 0.25);
		dmesh_5.position.set(0, 210, 210);
		QuadrupoleMaster.add(dmesh_5);			
		const dmesh_6 = new THREE.Mesh(geometry_5, redmaterial);
		dmesh_6.rotateX(Math.PI * 0.75);
		dmesh_6.position.set(0, 210, -210);
		QuadrupoleMaster.add(dmesh_6);			
		const dmesh_7 = new THREE.Mesh(geometry_5, redmaterial);
		dmesh_7.rotateX(Math.PI * 0.75);
		dmesh_7.position.set(0, -210, 210);
		QuadrupoleMaster.add(dmesh_7);			
		const dmesh_8 = new THREE.Mesh(geometry_5, redmaterial);
		dmesh_8.rotateX(Math.PI * 0.25);
		dmesh_8.position.set(0, -210, -210);
		QuadrupoleMaster.add(dmesh_8);			
		
		// coil basso destra 
		const d2mesh = new THREE.Mesh(coilgeometry, coilmaterials);
		d2mesh.position.set(0, -130, 120);
		d2mesh.rotateX(Math.PI * 1.25);
		d2mesh.rotateY(Math.PI * 1.50);
		d2mesh.rotateZ(Math.PI * 1.50);
		QuadrupoleMaster.add(d2mesh);

		// coil basso sinistra 
		const d3mesh = new THREE.Mesh(coilgeometry, coilmaterials);
		d3mesh.position.set(0, -130, -120);
		d3mesh.rotateX(Math.PI * 1.75);
		d3mesh.rotateY(Math.PI * 1.50);
		d3mesh.rotateZ(Math.PI * 1.50);
		QuadrupoleMaster.add(d3mesh);
		
		// coil alto destra 
		const d4mesh = new THREE.Mesh(coilgeometry, coilmaterials);
		d4mesh.position.set(0, 130, 120);
		d4mesh.rotateX(Math.PI * 0.75);
		d4mesh.rotateY(Math.PI * 1.50);
		d4mesh.rotateZ(Math.PI * 1.50);
		QuadrupoleMaster.add(d4mesh);

		// coil alto destra 
		const d5mesh = new THREE.Mesh(coilgeometry, coilmaterials);
		d5mesh.position.set(0, 130, -120);
		d5mesh.rotateX(Math.PI * 1.25);
		d5mesh.rotateY(Math.PI * 1.50);
		d5mesh.rotateZ(Math.PI * 1.50);
		QuadrupoleMaster.add(d5mesh);
		
		QuadrupoleMaster.position.set(0, 0, 0);
		QuadrupolContiner.add(QuadrupoleMaster);
		QuadrupolContiner.rotateY(Math.PI * -0.5);
				
		
		return QuadrupolContiner;
	}
	// BPM (beam position monitor)
	export function bpm(param) {
		const width=300, height=300, depth=50, transverse=100;
		const bpmObject = new THREE.Object3D();
		const bpmmaterial = new THREE.MeshLambertMaterial({color: 0x8000ff});
		const bpmgeometryh = new THREE.BoxGeometry(width, transverse, depth);
		const bpmmeshh = new THREE.Mesh(bpmgeometryh, bpmmaterial);
		bpmObject.add(bpmmeshh);
		const bpmgeometryv = new THREE.BoxGeometry(transverse, height, depth);
		const bpmmeshv = new THREE.Mesh(bpmgeometryv, bpmmaterial);
		bpmObject.add(bpmmeshv);
		return bpmObject;
	}


	// Beam Loss Monitor
	export function blm(param) {
		const length=30, dcolor='white', width=30;
		const cMaster = new THREE.Object3D();
		const d1geometry = new THREE.BoxGeometry(length, width, width);
		const material = new THREE.MeshLambertMaterial({color: dcolor});
		const d1mesh = new THREE.Mesh(d1geometry, material);
		d1mesh.position.set(-length/2, 0, 0);
		cMaster.add(d1mesh);
		return cMaster;
	}
	function blmColor(val) {
		if (document.location.search.indexOf('demo')>-1) {
			if (val < 0) return 'white';
			else if (val < 1) return 'yellow';
			else if (val < 2) return 'orange';
			else if (val < 3) return 'red';
			else return 'violet';
		}
		if (val < 20) return 'white';
		else if (val < 50) return 'yellow';
		else if (val < 100) return 'orange';
		else if (val < 200) return 'red';
		else return 'violet';
	}
	export function blmUpdate(c, val, direction, width=100, histogramFactor=50) {
		if (typeof val !== 'number') val = 0; else val = Math.abs(val);
		const blm = c.children[0];
		blm.material.dispose();
		blm.material = new THREE.MeshLambertMaterial({color: blmColor(val)});
		blm.geometry.dispose();
		blm.geometry = new THREE.BoxGeometry(width+val*histogramFactor, width, width);
		blm.position.set(direction*(width+val*histogramFactor)/2, 0, 0);
		blm.geometry.computeVertexNormals();
		blm.geometry.normalsNeedUpdate = true;
		blm.geometry.verticesNeedUpdate = true;
		blm.geometry.dynamic = true;
	}
	// Current Monitor	
	export function cm(param) {
		const cmContiner = new THREE.Object3D();
		const cmObject = new THREE.Object3D();
		
		//cylinder mid
		const cylgeometry = new THREE.CylinderGeometry(115, 115, 30, 20);
		const cylmaterial = new THREE.MeshLambertMaterial({color: 0x00d0ff});
		const cylmesh = new THREE.Mesh(cylgeometry, cylmaterial);
		cylmesh.rotateX(Math.PI * 1);
		cylmesh.rotateY(Math.PI * 1.0);
		cylmesh.rotateZ(Math.PI * 1.5);
		cylmesh.position.set(0, 0 , 0);			
		cmObject.add(cylmesh);			
		
		//cylinder center
		const cyl2geometry = new THREE.CylinderGeometry(75, 75, 31, 20);
		const cyl2material = new THREE.MeshLambertMaterial({color: 0x2d2b70});
		const cyl2mesh = new THREE.Mesh(cyl2geometry, cyl2material);
		cyl2mesh.rotateX(Math.PI * 1);
		cyl2mesh.rotateY(Math.PI * 1.0);
		cyl2mesh.rotateZ(Math.PI * 1.5);
		cyl2mesh.position.set(0, 0 , 0);			
		cmObject.add(cyl2mesh);			
		
			
		cmObject.scale.setX(1);
		cmObject.scale.setY(1);
		cmObject.scale.setZ(1);
		cmObject.position.set(0, 0, 0);
		cmContiner.add(cmObject);
		cmContiner.rotateY(Math.PI * -0.5);		
		
		
		return cmContiner;
	}

	// flsc
	export function flsc(param) {
		const length=700;
		const flscSR = new THREE.Object3D();
		const flscContiner = new THREE.Object3D();
		
		const materialGrey = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		const materialDarkGrey = new THREE.MeshLambertMaterial({color: 0x8c8c8c});
		const materialOrange= new THREE.MeshLambertMaterial({color: 0xfc9403});
		const materialBlack= new THREE.MeshLambertMaterial({color: 0x000000});
		
		//cil center
		const d1geometry = new THREE.CylinderGeometry(25, 25, 400, 25);
		const d1mesh = new THREE.Mesh(d1geometry, materialGrey);
		d1mesh.position.set(0, 200 , 0);
		flscContiner.add(d1mesh);
		flscContiner.rotateX(Math.PI * 1);
			
		// esagono
		const d2geometry = new THREE.CylinderGeometry(70, 70, 70, 6);
		const d2mesh = new THREE.Mesh(d2geometry, materialGrey);
		d2mesh.position.set(0, 290, 0);
		d2mesh.rotateX(Math.PI * 1);
		d2mesh.rotateY(Math.PI * 1);
		d2mesh.rotateZ(Math.PI * 1.5);		
		flscContiner.add(d2mesh);
		
		// box orange down
		const orangegeometry = new THREE.CylinderGeometry(90, 90, 250, 15);
		const orangegeometrymesh = new THREE.Mesh(orangegeometry, materialOrange);
		orangegeometrymesh.position.set(0, 550, 0);		
		flscContiner.add(orangegeometrymesh);
		
		// box black down
		const blackgeometry = new THREE.CylinderGeometry(90, 90, 25, 15);
		const blackgeometrymesh = new THREE.Mesh(blackgeometry, materialBlack);
		blackgeometrymesh.position.set(0, 412, 0);		
		flscContiner.add(blackgeometrymesh);			
		
		// base zigrinatura
		const d3geometry = new THREE.CylinderGeometry(90, 90, 50, 15);
		const d3mesh = new THREE.Mesh(d3geometry, materialGrey);
		d3mesh.rotateX(Math.PI * 1);
		d3mesh.rotateY(Math.PI * 1);
		d3mesh.rotateZ(Math.PI * 1);
		d3mesh.position.set(0, 170 , 0);			
		flscContiner.add(d3mesh);		
		
		// zigrinatura
		const d4geometry = new THREE.CylinderGeometry(60, 60, 170, 15);
		const textureLoader = new THREE.TextureLoader();
		const texture = textureLoader.load('./components/flsc_texture.png');	
		texture.wrapS = texture.wrapT = THREE.RepeatWrapping;
		texture.repeat.set(5, 40);		
		const material = new THREE.MeshBasicMaterial({ map: texture });		
		const d4mesh = new THREE.Mesh(d4geometry, material);
		d4mesh.rotateX(Math.PI * 1);
		d4mesh.rotateY(Math.PI * 1);
		d4mesh.rotateZ(Math.PI * 1);
		d4mesh.position.set(0, 60 , 0);			
		flscContiner.add(d4mesh);		
		
		// tetto zigrinatura
		const d5geometry = new THREE.CylinderGeometry(90, 90, 50, 15);
		const d5mesh = new THREE.Mesh(d5geometry, materialGrey);
		d5mesh.rotateX(Math.PI * 1);
		d5mesh.rotateY(Math.PI * 1);
		d5mesh.rotateZ(Math.PI * 1);
		d5mesh.position.set(0, -50 , 0);			
		flscContiner.add(d5mesh);	
		
		//half sphere down1
		const down1geometry = new THREE.CylinderGeometry(30, 30, 15, 25);
		const down1geometrymesh = new THREE.Mesh(down1geometry, materialGrey);
		down1geometrymesh.position.set(-75, 170, -75);
		flscContiner.add(down1geometrymesh);			
		
		//half sphere up1
		const up1geometry = new THREE.CylinderGeometry(30, 30, 15, 25);
		const up1geometrymesh = new THREE.Mesh(up1geometry, materialGrey);
		up1geometrymesh.position.set(-75, -50, -75);
		flscContiner.add(up1geometrymesh);	
		
		//half sphere down2
		const down2geometry = new THREE.CylinderGeometry(30, 30, 15, 25);
		const down2geometrymesh = new THREE.Mesh(down2geometry, materialGrey);
		down2geometrymesh.position.set(75, 170, -75);
		flscContiner.add(down2geometrymesh);			
		
		//half sphere up2
		const up2geometry = new THREE.CylinderGeometry(30, 30, 15, 25);
		const up2geometrymesh = new THREE.Mesh(up2geometry, materialGrey);
		up2geometrymesh.position.set(75, -50, -75);
		flscContiner.add(up2geometrymesh);	
		
		//half sphere down3
		const down3geometry = new THREE.CylinderGeometry(30, 30, 15, 25);
		const down3geometrymesh = new THREE.Mesh(down2geometry, materialGrey);
		down3geometrymesh.position.set(0, 170, 100);
		flscContiner.add(down3geometrymesh);			
		
		//half sphere up3
		const up3geometry = new THREE.CylinderGeometry(30, 30, 15, 25);
		const up3geometrymesh = new THREE.Mesh(up3geometry, materialGrey);
		up3geometrymesh.position.set(0, -50, 100);
		flscContiner.add(up3geometrymesh);			
				
		//cil support1
		const d11geometry = new THREE.CylinderGeometry(10, 10, 300, 25);
		const d11mesh = new THREE.Mesh(d11geometry, materialGrey);
		d11mesh.position.set(-75, 20, -75);
		flscContiner.add(d11mesh);	
		
		//cil support2
		const d12geometry = new THREE.CylinderGeometry(10, 10, 300, 25);
		const d12mesh = new THREE.Mesh(d12geometry, materialGrey);
		d12mesh.position.set(75, 20, -75);
		flscContiner.add(d12mesh);				
		
		//cil support3
		const d13geometry = new THREE.CylinderGeometry(10, 10, 300, 25);
		const d13mesh = new THREE.Mesh(d13geometry, materialGrey);
		d13mesh.position.set(0, 20, 100);
		flscContiner.add(d13mesh);				
	
		// blocco supporto
		const d15geometry = new THREE.CylinderGeometry(120, 120, 20, 25);
		const d15mesh = new THREE.Mesh(d15geometry, materialGrey);
		d15mesh.position.set(0, -130, 0);
		d15mesh.rotateX(Math.PI * 1);
		flscContiner.add(d15mesh);	
		
		//internal block
		const d16geometry = new THREE.CylinderGeometry(20, 20, 60, 15);
		const d16mesh = new THREE.Mesh(d16geometry, materialGrey);
		d16mesh.position.set(0, -100, 0);
		d16mesh.rotateX(Math.PI * 1);
		flscContiner.add(d16mesh);			
		
		// high box1 
		const d7geometry = new THREE.BoxGeometry(40, 90, 100);
		const d7mesh = new THREE.Mesh(d7geometry, materialDarkGrey);
		d7mesh.position.set(-20, -180, 0);		
		flscContiner.add(d7mesh);				
		
		// high box2
		const d8geometry = new THREE.BoxGeometry(40, 60, 100);
		const d8mesh = new THREE.Mesh(d8geometry, materialDarkGrey);
		d8mesh.position.set(20, -170, 0);		
		flscContiner.add(d8mesh);			

		flscContiner.position.set(0, 290, 0);
		flscSR.add(flscContiner);
		flscSR.rotateY(Math.PI * -0.5);
		return flscSR;
	}

	// lens
	export function lens(param) {
		const lensContiner = new THREE.Object3D();
		const lensObject = new THREE.Object3D();
		
		//cylinder mid
		const cylgeometry = new THREE.CylinderGeometry(105, 105, 30, 20);
		const cylmaterial = new THREE.MeshLambertMaterial({color: 0xc7c7c7});
		const cylmesh = new THREE.Mesh(cylgeometry, cylmaterial);
		cylmesh.rotateX(Math.PI * 1);
		cylmesh.rotateY(Math.PI * 1.0);
		cylmesh.rotateZ(Math.PI * 1.5);
		cylmesh.position.set(0, 0 , 0);			
		lensObject.add(cylmesh);			
		
		//cylinder center
		const cyl2geometry = new THREE.CylinderGeometry(75, 75, 31, 20);
		const cyl2material = new THREE.MeshLambertMaterial({color: 0x737373});
		const cyl2mesh = new THREE.Mesh(cyl2geometry, cyl2material);
		cyl2mesh.rotateX(Math.PI * 1);
		cyl2mesh.rotateY(Math.PI * 1.0);
		cyl2mesh.rotateZ(Math.PI * 1.5);
		cyl2mesh.position.set(0, 0 , 0);			
		lensObject.add(cyl2mesh);			
		
		// base1
		const basegeometry = new THREE.BoxGeometry(29, 160, 60 );
		const basemesh = new THREE.Mesh(basegeometry, cylmaterial);
		basemesh.position.set(0, -70, 0);
		lensObject.add(basemesh);		
		
			
		lensObject.scale.setX(1);
		lensObject.scale.setY(1);
		lensObject.scale.setZ(1);
		lensObject.position.set(0, 0, 0);
		lensContiner.add(lensObject);
		lensContiner.rotateY(Math.PI * 0.5);		
		
		return lensContiner;
	}

	// corrector booster
	export function correctorbooster(param) {
		const length=140;
		const CorrectorContiner = new THREE.Object3D();
		const correctorObject = new THREE.Object3D();
		
		// box esterno
		const correctormaterial = new THREE.MeshLambertMaterial({color: 0x4040b0});
		const correctorgeometry = new THREE.BoxGeometry(140, 65, length);
		const d1mesh = new THREE.Mesh(correctorgeometry, correctormaterial);
		correctormaterial.flatShading = true;
		d1mesh.position.set(0, 0, 0);
		d1mesh.rotateX(Math.PI * 1.250);
		d1mesh.rotateY(Math.PI * 1.5);
		d1mesh.rotateZ(Math.PI * 1.25);	
		d1mesh.position.set(0, 0, 0);
		correctorObject.add(d1mesh);
		
		// box lato1
		const correctormaterial2 = new THREE.MeshLambertMaterial({color: 0x4040b0});
		const correctorgeometry2 = new THREE.BoxGeometry(140, 20, 140 );
		const d2mesh = new THREE.Mesh(correctorgeometry2, correctormaterial2);
		correctormaterial.flatShading = true;
		d2mesh.position.set(0, 0, 0);
		d2mesh.rotateX(Math.PI * 1.5);
		d2mesh.rotateY(Math.PI * 1);
		d2mesh.rotateZ(Math.PI * 1.5);	
		d2mesh.position.set(-80, 37, 0);
		correctorObject.add(d2mesh);		
		
		// box lato2
		const correctormaterial3 = new THREE.MeshLambertMaterial({color: 0x4040b0});
		const correctorgeometry3 = new THREE.BoxGeometry(140, 20, 140 );
		const d3mesh = new THREE.Mesh(correctorgeometry3, correctormaterial3);
		correctormaterial.flatShading = true;
		d3mesh.position.set(0, 0, 0);
		d3mesh.rotateX(Math.PI * 1.5);
		d3mesh.rotateY(Math.PI * 1);
		d3mesh.rotateZ(Math.PI * 1.5);	
		d3mesh.position.set(80, 37, 0);
		correctorObject.add(d3mesh);		
		
		//Coil
		const d4geometry = new THREE.CylinderGeometry(30, 30, 140, 15);
		const correctormaterial4 = new THREE.MeshLambertMaterial({color: 0xc08000});
		const d4mesh = new THREE.Mesh(d4geometry, correctormaterial4);
		d4mesh.rotateX(Math.PI);
		d4mesh.rotateY(Math.PI);
		d4mesh.rotateZ(Math.PI * 1.5);
		d4mesh.position.set(0, 100, 0);			
		correctorObject.add(d4mesh);				

		correctorObject.position.set(0, -150, 0);
		correctorObject.scale.setX(3);
		correctorObject.scale.setY(3);
		CorrectorContiner.add(correctorObject);
		CorrectorContiner.rotateY(Math.PI * -1);

		return CorrectorContiner;
	}


	// cavity for linac
	export function cavitylinac(param) {
		const length = param && typeof param.length == "number"? param.length: 1500;
		const cavitylinacMaster = new THREE.Object3D();
		const dmaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		const d1geometry = new THREE.CylinderGeometry(200, 200, length, 25);
		const d1mesh = new THREE.Mesh(d1geometry, dmaterial);
		cavitylinacMaster.add(d1mesh);				
		cavitylinacMaster.rotateX(Math.PI * 0.5);
		cavitylinacMaster.rotatedX = true;
		return cavitylinacMaster;
	}


	// Bending Dipole booster
	export function dipolebooster(length = 1615) {
		const dipoleContainer = new THREE.Object3D();
		const dipoleMaster = new THREE.Object3D();

		//texture
		const loader = new THREE.TextureLoader();
		const texture = loader.load('./components/dipole.png');
		const textureTop = texture.clone();
		const textureSide = texture.clone();
		textureTop.center.set(0.5, 0.5);
		textureTop.rotation = THREE.MathUtils.degToRad(90);
		textureSide.offset.set(0, 0.8);
		const dmaterial = new THREE.MeshLambertMaterial({map: texture});
		const face = new THREE.MeshBasicMaterial({map: texture});
		const faceTop = new THREE.MeshBasicMaterial({map: textureTop});
		const faceSide = new THREE.MeshBasicMaterial({map: textureSide});
		const materials = [face,face,faceTop,faceSide,faceSide,faceSide];
		const d1geometry = new THREE.BoxGeometry(550, 400, length);
		const d1mesh = new THREE.Mesh(d1geometry, materials);
		d1mesh.position.set(-100, 100, 0);
		dipoleMaster.add(d1mesh);	

		//Coil
		const dipoleCoil = new THREE.Object3D();
		const coilmaterial = new THREE.MeshLambertMaterial({color: 0xc08000});
		const d4geometry = new THREE.BoxGeometry(100, 100, length);
		const d4mesh = new THREE.Mesh(d4geometry, coilmaterial);
		d4mesh.position.set(-200, 0, 0);
		dipoleCoil.add(d4mesh);
		const d2geometry = new THREE.CylinderGeometry(150 /*radiusTop*/, 150 /*radiusBottom*/, 100 /*height*/, 20 /*radialSegments*/, 2 /*heightSegments*/, false /*openEnded*/,Math.PI * 1.5 /*thetaStart*/, Math.PI * 1 /*thetaLength*/);
		const d2mesh = new THREE.Mesh(d2geometry, coilmaterial);
		d2mesh.position.set(-100, 0, length/2);
		dipoleCoil.add(d2mesh);
		const d3geometry = new THREE.CylinderGeometry(150 /*radiusTop*/, 150 /*radiusBottom*/, 100 /*height*/, 20 /*radialSegments*/, 2 /*heightSegments*/, false /*openEnded*/,Math.PI * 0.5 /*thetaStart*/, Math.PI * 1 /*thetaLength*/);
		const d3mesh = new THREE.Mesh(d3geometry, coilmaterial);
		d3mesh.position.set(-100, 0, -length/2);
		dipoleCoil.add(d3mesh);
		dipoleCoil.position.set(0, 0, 0);
		dipoleMaster.add(dipoleCoil);
		const dipoleCoil2 = dipoleCoil.clone();
		dipoleCoil2.position.set(0, 200, 0);
		dipoleMaster.add(dipoleCoil2);

		dipoleMaster.position.set(200, 0, 0);
		dipoleContainer.add(dipoleMaster);

		return dipoleContainer;
	}

	// sextupole booster
	export function sextupolebooster(param) {
		const length = param && typeof param.length == "number"? param.length: 110;
		const SextupoleContiner = new THREE.Object3D();
		const SextupoleMaster = new THREE.Object3D();
		const dmaterial = new THREE.MeshLambertMaterial({color: 0xFFE000});

		// support high
		const geometry_1 = new THREE.BoxGeometry(length, 100, 200);
		const dmesh_1 = new THREE.Mesh(geometry_1, dmaterial);
		dmesh_1.position.set(0, 324, 0);
		SextupoleMaster.add(dmesh_1);
		
		// support side
		const dmesh_2 = new THREE.Mesh(geometry_1, dmaterial);
		dmesh_2.position.set(0, 280, -162);
		dmesh_2.rotateX(-Math.PI / 6);
		SextupoleMaster.add(dmesh_2);

		const geometry3 = new THREE.BoxGeometry(length-30, 120, 50);
		const dmesh3 = new THREE.Mesh(geometry3, dmaterial);
		dmesh3.position.set(0, 140, 0);
		SextupoleMaster.add(dmesh3);		

		// coil
		const coilmaterial = new THREE.MeshLambertMaterial({color: 0xc08000});
		const textureLoader = new THREE.TextureLoader();
		const texture = textureLoader.load('./components/coil_texture.png');
		texture.wrapS = texture.wrapT = THREE.RepeatWrapping;
		texture.repeat.set(5, 5);
		const d6geometry = new THREE.CylinderGeometry(80 /*radiusTop*/, 80 /*radiusBottom*/, 80 /*height*/, 25 /*radialSegments*/, 4 /*heightSegments*/, false /*openEnded*/,Math.PI * 1.5 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		const material6 = new THREE.MeshBasicMaterial({ map: texture });
		const materialside6 = new THREE.MeshBasicMaterial({color: 0xcd7f32});
		const materials6 = [material6, materialside6, materialside6];		
		const d6mesh = new THREE.Mesh(d6geometry, materials6);
		d6mesh.position.set(0, 230, 0);
		d6mesh.rotateX(Math.PI * 1.50);
		d6mesh.rotateY(Math.PI * 1.50);
		d6mesh.rotateZ(Math.PI * 1.50);
		SextupoleMaster.add(d6mesh);

		for (let i=1; i<6; i++) {
			const Sextupole2 = SextupoleMaster.clone();
			Sextupole2.rotateX(-Math.PI / 3*i);
			SextupoleContiner.add(Sextupole2);
		}
		SextupoleContiner.add(SextupoleMaster);
		SextupoleContiner.rotateY(Math.PI * -0.5);
		return SextupoleContiner;
	}

	// kicker
	export function kicker(param) {
		const length = param && typeof param.length == "number"? param.length: 300;
		const kickerMaster = new THREE.Object3D();

		const d1geometry = new THREE.BoxGeometry(710, 500, 500);
		const dmaterial = new THREE.MeshLambertMaterial({color: 0x405040});
		const d1mesh = new THREE.Mesh(d1geometry, dmaterial);
		d1mesh.position.set(0, -20, 330);
		kickerMaster.add(d1mesh);				

		//add quad2
		const d2geometry = new THREE.BoxGeometry(710, 270, 300);
		const dmaterial2= new THREE.MeshLambertMaterial({color: 0x405040});
		const d2mesh = new THREE.Mesh(d2geometry, dmaterial2);
		d2mesh.position.set(0, -135, 80);
		kickerMaster.add(d2mesh);

		//add sest
		const d3geometry = new THREE.CylinderGeometry(300, 300, 700, 6);
		const dmateria3 = new THREE.MeshLambertMaterial({color: 0xffff00});
		const textureLoader = new THREE.TextureLoader();
		const texture = textureLoader.load('./components/kicker_texture.png');
		texture.wrapS = texture.wrapT = THREE.RepeatWrapping;
		texture.repeat.set(5, 40);
		const material = new THREE.MeshBasicMaterial({ map: texture });
		const d3mesh = new THREE.Mesh(d3geometry, material);
		d3mesh.rotateX(Math.PI * 1);
		d3mesh.rotateY(Math.PI * 1);
		d3mesh.rotateZ(Math.PI * 1.5);
		d3mesh.position.set(0, 0 , 230);
		kickerMaster.add(d3mesh);				

		//capsule
		const geometry = new THREE.CapsuleGeometry( 50, 50, 40, 80 ); 
		const material_cap = new THREE.MeshBasicMaterial( {color: 0xff0000} ); 
		const d4mesh = new THREE.Mesh( geometry, material_cap ); 
		d4mesh.position.set(0, 240 , 480);
		kickerMaster.add(d4mesh);

		kickerMaster.rotateY(Math.PI * 0.5);
		return kickerMaster;
	}

	// septum
		export function spte(param) {
		const length = param && typeof param.length == "number"? param.length: 1000;
			const septumSR = new THREE.Object3D();
			const dmaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
			const d1geometry = new THREE.CylinderGeometry(200, 200, length, 25);
			const d1mesh = new THREE.Mesh(d1geometry, dmaterial);
			septumSR.add(d1mesh);				
			septumSR.rotateX(Math.PI * 0.5);
			septumSR.rotatedX = true;	

			// left
			const dmateria2 = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
			const d2geometry = new THREE.CylinderGeometry(250, 250, 100, 25);
			const d2mesh = new THREE.Mesh(d2geometry, dmateria2);
			d2mesh.position.set(0, -length/2-50, 0);
			septumSR.add(d2mesh);

			// right
			const dmateria3 = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
			const d3geometry = new THREE.CylinderGeometry(250, 250, 100, 25);
			const d3mesh = new THREE.Mesh(d3geometry, dmateria3);
			d3mesh.position.set(0, length/2+50, 0);
			septumSR.add(d3mesh);

			// up1
			const dmateria4 = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
			const d4geometry = new THREE.CylinderGeometry(100, 100, 100, 25);
			const d4mesh = new THREE.Mesh(d4geometry, dmateria4);
			d4mesh.rotateX(Math.PI * 0.5);
			d4mesh.rotateY(Math.PI * 1);
			d4mesh.rotateZ(Math.PI * 1);
			d4mesh.position.set(0, -300 , -200);		
			septumSR.add(d4mesh);

			// up2
			const dmateria5 = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
			const d5geometry = new THREE.CylinderGeometry(100, 100, 100, 25);
			const d5mesh = new THREE.Mesh(d5geometry, dmateria5);
			d5mesh.rotateX(Math.PI * 0.5);
			d5mesh.rotateY(Math.PI * 1);
			d5mesh.rotateZ(Math.PI * 1);
			d5mesh.position.set(0, 300 , -200);		
			septumSR.add(d5mesh);
			
			septumSR.scale.setY(0.7);

			return septumSR;
		}


	// cavity
	export function cavity(param) {
		const sphereRadius=300, sphereFactor=0.5, cylinderRadius=40, cylinderHeight=600;
		const cavityObject = new THREE.Object3D();
		const cavitymaterial = new THREE.MeshLambertMaterial({color: 0xb0b0b0});
		const cavitygeometry = new THREE.SphereGeometry(sphereRadius, 32, 32);
		const cavitymesh = new THREE.Mesh(cavitygeometry, cavitymaterial);
		cavitymesh.scale.setZ(sphereFactor);
		cavityObject.add(cavitymesh);
		const rfGeometry = new THREE.CylinderGeometry(cylinderRadius, cylinderRadius,  cylinderHeight, 20, 2, false, 0, Math.PI * 2);
		const rfMesh = new THREE.Mesh(rfGeometry, cavitymaterial);
		// rfMesh.rotateX(Math.PI * 0.5);
		rfMesh.position.set(0, sphereRadius, 0);
		cavityObject.add(rfMesh);
		return cavityObject;
	}

	/* corrector2
	export function corrector2(param) {
		const length = param && typeof param.length == "number"? param.length: 170;
		const CorrectorContiner = new THREE.Object3D();
		const correctorObject = new THREE.Object3D();
		
		// box esterno
		const correctormaterial = new THREE.MeshLambertMaterial({color: 0x4040b0, side: THREE.DoubleSide});
		const d1mesh = new THREE.Mesh(correctorgeometry, correctormaterial);
		correctormaterial.flatShading = true;
		d1mesh.position.set(0, 0, 0);
		d1mesh.rotateX(Math.PI * 1.25);
		d1mesh.rotateY(Math.PI * 1);
		d1mesh.rotateZ(Math.PI * 1.5);	
		correctorObject.add(d1mesh);
		
		// box up
		const correctormaterial2 = new THREE.MeshLambertMaterial({color: 0x4040b0});
		const correctorgeometry2 = new THREE.CylinderGeometry(55, 55, 120);
		const d2mesh = new THREE.Mesh(correctorgeometry2, correctormaterial2);
		d2mesh.position.set(0, 100, 0);
		d2mesh.rotateX(Math.PI * 1.5);
		correctorObject.add(d2mesh);		
		
		// box left
		const correctormaterial3 = new THREE.MeshLambertMaterial({color: 0x4040b0});
		const correctorgeometry3 = new THREE.CylinderGeometry(55, 55, 120);
		const d3mesh = new THREE.Mesh(correctorgeometry3, correctormaterial3);
		d3mesh.position.set(0, -40, 100);
		d3mesh.rotateX(Math.PI * 1.0);
		correctorObject.add(d3mesh);		
		
		// box right
		const correctormaterial4 = new THREE.MeshLambertMaterial({color: 0x4040b0});
		const correctorgeometry4 = new THREE.CylinderGeometry(55, 55, 120);
		const d4mesh = new THREE.Mesh(correctorgeometry4, correctormaterial4);
		d4mesh.position.set(-0, -40, -100);
		d4mesh.rotateX(Math.PI * 1.0);
		correctorObject.add(d4mesh);		
		
		correctorObject.position.set(0, 0, 0);
		CorrectorContiner.add(correctorObject);
		CorrectorContiner.rotateY(Math.PI * -0.5);		
		
		// status
		const faultMaterial = new THREE.MeshBasicMaterial({ color: 0xe00000, transparent: true, opacity: 1 });
		const warningMaterial = new THREE.MeshBasicMaterial({ color: 0xffff66, transparent: true, opacity: 1 });
		const normalMaterial = new THREE.MeshBasicMaterial({ color: 0xffff66, transparent: true, opacity: 0 });
		const sphereGeometry = new THREE.SphereGeometry(100, 10, 10);
		const sphere = new THREE.Mesh(sphereGeometry, normalMaterial);
		sphere.position.set(0, 350, 0);
		correctorObject.add(sphere);
		
		return CorrectorContiner;
	}
     */
	// corrector
	export function corrector(param) {
		const length = param && typeof param.length == "number"? param.length: 170;
		const CorrectorContiner = new THREE.Object3D();
		const correctorObject = new THREE.Object3D();
		
		// box esterno
		const correctormaterial = new THREE.MeshLambertMaterial({color: 0x4040b0, side: THREE.DoubleSide});
		const correctorgeometry = new THREE.CylinderGeometry(250 /*radiusTop*/, 250 /*radiusBottom*/, length /*height*/, 4 /*radialSegments*/, 2 /*heightSegments*/, true /*openEnded*/,0 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		const d1mesh = new THREE.Mesh(correctorgeometry, correctormaterial);
		correctormaterial.flatShading = true;
		d1mesh.position.set(0, 0, 0);
		d1mesh.rotateX(Math.PI * 1.25);
		d1mesh.rotateY(Math.PI * 1);
		d1mesh.rotateZ(Math.PI * 1.5);	
		correctorObject.add(d1mesh);
		
		// box up
		const correctormaterial2 = new THREE.MeshLambertMaterial({color: 0x4040b0});
		const correctorgeometry2 = new THREE.CylinderGeometry(55, 55, 120);
		const d2mesh = new THREE.Mesh(correctorgeometry2, correctormaterial2);
		d2mesh.position.set(0, 100, 0);
		d2mesh.rotateX(Math.PI * 1.5);
		correctorObject.add(d2mesh);		
		
		// box left
		const correctormaterial3 = new THREE.MeshLambertMaterial({color: 0x4040b0});
		const correctorgeometry3 = new THREE.CylinderGeometry(55, 55, 120);
		const d3mesh = new THREE.Mesh(correctorgeometry3, correctormaterial3);
		d3mesh.position.set(0, -40, 100);
		d3mesh.rotateX(Math.PI * 1.0);
		correctorObject.add(d3mesh);		
		
		// box right
		const correctormaterial4 = new THREE.MeshLambertMaterial({color: 0x4040b0});
		const correctorgeometry4 = new THREE.CylinderGeometry(55, 55, 120);
		const d4mesh = new THREE.Mesh(correctorgeometry4, correctormaterial4);
		d4mesh.position.set(-0, -40, -100);
		d4mesh.rotateX(Math.PI * 1.0);
		correctorObject.add(d4mesh);		
		
		correctorObject.position.set(0, 0, 0);
		CorrectorContiner.add(correctorObject);
		CorrectorContiner.rotateY(Math.PI * -0.5);		
		
		
		return CorrectorContiner;
	}


	// Bending Dipole
	export function dipole(length = 1449) {
		const dipoleMaster = new THREE.Object3D();

		// main body
		const loader = new THREE.TextureLoader();
		const texture = loader.load('./components/dipole.png');
		const textureTop = texture.clone();
		const textureSide = texture.clone();
		textureTop.center.set(0.5, 0.5);
		textureTop.rotation = THREE.MathUtils.degToRad(90);
		textureSide.offset.set(0, 0.8);
		const dmaterial = new THREE.MeshLambertMaterial({map: texture});
		const face = new THREE.MeshBasicMaterial({map: texture});
		const faceTop = new THREE.MeshBasicMaterial({map: textureTop});
		const faceSide = new THREE.MeshBasicMaterial({map: textureSide});
		const materials = [face,face,faceTop,faceSide,faceSide,faceSide];
		const d1geometry = new THREE.BoxGeometry(500, 700, length);
		const d1mesh = new THREE.Mesh(d1geometry, materials);
		d1mesh.position.set(100, 100, 0);
		dipoleMaster.add(d1mesh);

		// longitudinal coil
		const dipoleCoil = new THREE.Object3D();
		const coilmaterial = new THREE.MeshLambertMaterial({color: 0xc08000});
		const d4geometry = new THREE.BoxGeometry(100, 100, length);
		const d4mesh = new THREE.Mesh(d4geometry, coilmaterial);
		d4mesh.position.set(-200, 0, 0);
		dipoleCoil.add(d4mesh);

		// cylinder coil front
		const d2geometry = new THREE.CylinderGeometry(150 /*radiusTop*/, 150 /*radiusBottom*/, 100 /*height*/, 20 /*radialSegments*/, 2 /*heightSegments*/, false /*openEnded*/,Math.PI * 1.5 /*thetaStart*/, Math.PI * 1 /*thetaLength*/);
		const d2mesh = new THREE.Mesh(d2geometry, coilmaterial);
		d2mesh.position.set(-100, 0, length/2);
		dipoleCoil.add(d2mesh);

		// cylinder coil back
		const d3geometry = new THREE.CylinderGeometry(150 /*radiusTop*/, 150 /*radiusBottom*/, 100 /*height*/, 20 /*radialSegments*/, 2 /*heightSegments*/, false /*openEnded*/,Math.PI * 0.5 /*thetaStart*/, Math.PI * 1 /*thetaLength*/);
		const d3mesh = new THREE.Mesh(d3geometry, coilmaterial);
		d3mesh.position.set(-100, 0, -length/2);
		dipoleCoil.add(d3mesh);
		dipoleCoil.position.set(0, 0, 0);
		dipoleMaster.add(dipoleCoil);

		// duplicate coil
		const dipoleCoil2 = dipoleCoil.clone();
		dipoleCoil2.position.set(0, 200, 0);
		dipoleMaster.add(dipoleCoil2);
		return dipoleMaster;
	}


	// Quadrupole
	export function quadrupole(param) {
		const length = param && typeof param.length == "number"? param.length: 260;
		const quadrupoleMaster = new THREE.Object3D();
		const chamberMaterial = new THREE.MeshLambertMaterial({color: 0xc0c0c0});
		const quadrupolematerial = new THREE.MeshLambertMaterial({color: 0xff7050});
		const quadrupolegeometry = new THREE.CylinderGeometry(250, 250, length, 8);
		const quadrupolemesh = new THREE.Mesh(quadrupolegeometry, quadrupolematerial);
		quadrupoleMaster.add(quadrupolemesh);
		const quadrupole2geometry = new THREE.CylinderGeometry(290, 290, 30, 50);
		const quadrupole2mesh = new THREE.Mesh(quadrupole2geometry, chamberMaterial);
		quadrupole2mesh.position.set(0, -length/2-15, 0);
		quadrupoleMaster.add(quadrupole2mesh);
		const quadrupole3mesh = new THREE.Mesh(quadrupole2geometry, chamberMaterial);
		quadrupole3mesh.position.set(0, length/2+15, 0);
		quadrupoleMaster.add(quadrupole3mesh);
		quadrupoleMaster.rotateX(Math.PI * 0.5);
		quadrupoleMaster.rotatedX = true;
		const qedges = new THREE.EdgesGeometry(quadrupolegeometry);
		const lineMaterial = new THREE.LineBasicMaterial({color: 0x600000});
		lineMaterial.linewidth = 4;
		const qline = new THREE.LineSegments(qedges, lineMaterial);
		quadrupoleMaster.add(qline);
		return quadrupoleMaster;
	}


	// Sextupole
	export function sextupole(param) {
		const length = param && typeof param.length == "number"? param.length: 230;
		const sextupoleMaster = new THREE.Object3D();
		const chamberMaterial = new THREE.MeshLambertMaterial({color: 0xc0c0c0});
		const sextupolematerial = new THREE.MeshLambertMaterial({color: 0xffff00});
		const sextupolegeometry = new THREE.CylinderGeometry(250, 250, length, 6);
		const sextupolemesh = new THREE.Mesh(sextupolegeometry, sextupolematerial);
		sextupoleMaster.add(sextupolemesh);
		const sextupole2geometry = new THREE.CylinderGeometry(290, 290, 30, 50);
		const sextupole2mesh = new THREE.Mesh(sextupole2geometry, chamberMaterial);
		sextupole2mesh.position.set(0, -length/2-15, 0);
		sextupoleMaster.add(sextupole2mesh);
		const sextupole3mesh = new THREE.Mesh(sextupole2geometry, chamberMaterial);
		sextupole3mesh.position.set(0, length/2+15, 0);
		sextupoleMaster.add(sextupole3mesh);
		sextupoleMaster.rotateX(Math.PI * 0.5);
		sextupoleMaster.rotatedX = true;
		const sedges = new THREE.EdgesGeometry(sextupolegeometry);
		const sline = new THREE.LineSegments(sedges, new THREE.LineBasicMaterial({color: 0x808000}));
		sextupoleMaster.add(sline);
		return sextupoleMaster;
	}


	// undulator
	export function undulator(param) {
		const length = param && typeof param.length == "number"? param.length: 1300;
		const undulatorMaster = new THREE.Object3D();
		const chamberMaterial = new THREE.MeshLambertMaterial({color: 0xc0c0c0});
		const loader = new THREE.TextureLoader();
		const texture = loader.load('./components/undulator.png');
		const textureTop = texture.clone();
		const textureSide = texture.clone();
		textureTop.wrapS = textureTop.wrapT = THREE.RepeatWrapping;
		textureTop.repeat.set(30, 1);
		textureSide.offset.set(0.95, 0.95);
		const face = new THREE.MeshBasicMaterial({map: texture});
		const faceTop = new THREE.MeshBasicMaterial({map: textureTop});
		const faceSide = new THREE.MeshBasicMaterial({map: textureSide});
		const materials = [faceTop,faceTop,chamberMaterial,chamberMaterial,chamberMaterial,chamberMaterial];
		const ugeometry = new THREE.BoxGeometry(400, 400, length);
		const umesh = new THREE.Mesh(ugeometry, materials);
		undulatorMaster.add(umesh);				
		const qedges = new THREE.EdgesGeometry(ugeometry);
		const lineMaterial = new THREE.LineBasicMaterial({color: 0x000000});
		lineMaterial.linewidth = 4;
		const qline = new THREE.LineSegments(qedges, lineMaterial);
		undulatorMaster.add(qline);
		return undulatorMaster;
	}


	// wiggler
	export function wiggler(param) {
		const length = param && typeof param.length == "number"? param.length: 1300;
		const wigglerMaster = new THREE.Object3D();
		const chamberMaterial = new THREE.MeshLambertMaterial({color: 0xf3a1eb});
		const loader = new THREE.TextureLoader();
		const texture = loader.load('./components/wiggler.png');
		const textureTop = texture.clone();
		const textureSide = texture.clone();
		textureTop.wrapS = textureTop.wrapT = THREE.RepeatWrapping;
		textureTop.repeat.set(30, 1);
		textureSide.offset.set(0.95, 0.95);
		const face = new THREE.MeshBasicMaterial({map: texture});
		const faceTop = new THREE.MeshBasicMaterial({map: textureTop});
		const faceSide = new THREE.MeshBasicMaterial({map: textureSide});
		const materials = [faceTop,faceTop,chamberMaterial,chamberMaterial,chamberMaterial,chamberMaterial];
		const ugeometry = new THREE.BoxGeometry(400, 400, length);
		const umesh = new THREE.Mesh(ugeometry, materials);
		wigglerMaster.add(umesh);				
		const qedges = new THREE.EdgesGeometry(ugeometry);
		const lineMaterial = new THREE.LineBasicMaterial({color: 0x000000});
		lineMaterial.linewidth = 4;
		const qline = new THREE.LineSegments(qedges, lineMaterial);
		wigglerMaster.add(qline);
		return wigglerMaster;
	}


	// 3hc
	export function cavity_3hc(param) {
		const length = param && typeof param.length == "number"? param.length: 1500;
		const threeHCSR = new THREE.Object3D();
		const dmaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		const dmaterial2 = new THREE.MeshLambertMaterial({color: 0xffffff});
		const d1geometry = new THREE.CylinderGeometry(700, 700, length, 35);
		const d1mesh = new THREE.Mesh(d1geometry, dmaterial);
		threeHCSR.add(d1mesh);				
		threeHCSR.rotateX(Math.PI * 0.5);
		threeHCSR.rotatedX = true;	

		// left
		const lrgeometry = new THREE.CylinderGeometry(750, 750, 100, 65);
		const d2mesh = new THREE.Mesh(lrgeometry, dmaterial);
		d2mesh.position.set(0, -length/2-50, 0);
		threeHCSR.add(d2mesh);

		// right
		const d3mesh = new THREE.Mesh(lrgeometry, dmaterial);
		d3mesh.position.set(0, length/2+50, 0);
		threeHCSR.add(d3mesh);

		// up1
		const udgeometry = new THREE.CylinderGeometry(250, 250, 100, 25);
		const d4mesh = new THREE.Mesh(udgeometry, dmaterial);
		d4mesh.rotateX(Math.PI * 0.5);
		d4mesh.rotateY(Math.PI * 1);
		d4mesh.rotateZ(Math.PI * 1);
		d4mesh.position.set(0, -400 , -730);		
		threeHCSR.add(d4mesh);

		// up2
		const udgeometry2 = new THREE.CylinderGeometry(150, 150, 100, 25);
		const d5mesh = new THREE.Mesh(udgeometry2, dmaterial);
		d5mesh.rotateX(Math.PI * 0.5);
		d5mesh.rotateY(Math.PI * 1);
		d5mesh.rotateZ(Math.PI * 1);
		d5mesh.position.set(0, 400 , -730);		
		threeHCSR.add(d5mesh);

		// up1a
		const udgeometrya = new THREE.CylinderGeometry(200, 200, 250, 25);
		const d6mesh = new THREE.Mesh(udgeometrya, dmaterial);
		d6mesh.rotateX(Math.PI * 0.5);
		d6mesh.rotateY(Math.PI * 1);
		d6mesh.rotateZ(Math.PI * 1);
		d6mesh.position.set(0, -400 , -870);		
		threeHCSR.add(d6mesh);		
		
		// up1b
		const udgeometryb = new THREE.CylinderGeometry(250, 250, 100, 25);
		const d7mesh = new THREE.Mesh(udgeometryb, dmaterial);
		d7mesh.rotateX(Math.PI * 0.5);
		d7mesh.rotateY(Math.PI * 1);
		d7mesh.rotateZ(Math.PI * 1);
		d7mesh.position.set(0, -400 , -1000);		
		threeHCSR.add(d7mesh);	
		
		// up1c
		const udgeometryc = new THREE.CylinderGeometry(200, 200, 400, 25);
		const d8mesh = new THREE.Mesh(udgeometryc, dmaterial);
		d8mesh.rotateX(Math.PI * 0.5);
		d8mesh.rotateY(Math.PI * 1);
		d8mesh.rotateZ(Math.PI * 1);
		d8mesh.position.set(0, -400 , -1100);		
		threeHCSR.add(d8mesh);	
		
		// up2d
		const udgeometry2d = new THREE.CylinderGeometry(100, 100, 200, 25);
		const d9mesh = new THREE.Mesh(udgeometry2d, dmaterial);
		d9mesh.rotateX(Math.PI * 0.5);
		d9mesh.rotateY(Math.PI * 1);
		d9mesh.rotateZ(Math.PI * 1);
		d9mesh.position.set(0, 400 , -830);		
		threeHCSR.add(d9mesh);		

		// up2e
		const udgeometry2e = new THREE.CylinderGeometry(130, 130, 100, 25);
		const d10mesh = new THREE.Mesh(udgeometry2e, dmaterial);
		d10mesh.rotateX(Math.PI * 0.5);
		d10mesh.rotateY(Math.PI * 1);
		d10mesh.rotateZ(Math.PI * 1);
		d10mesh.position.set(0, 400 , -930);		
		threeHCSR.add(d10mesh);			
		
		
		//tubo1
		const tubegeometry1 = new THREE.CylinderGeometry(30, 30, 1100, 25);
		const d12mesh = new THREE.Mesh(tubegeometry1, dmaterial);
		d12mesh.rotateX(Math.PI * 0.5);
		d12mesh.rotateY(Math.PI * 0.5);
		d12mesh.rotateZ(Math.PI * 0.5);
		d12mesh.position.set(-430, -150 , -930);		
		threeHCSR.add(d12mesh);	
		
		//tubo2
		const tubegeometry2 = new THREE.CylinderGeometry(30, 30, 450, 25);
		const d13mesh = new THREE.Mesh(tubegeometry2, dmaterial);
		d13mesh.rotateX(Math.PI * 0.5);
		d13mesh.rotateY(Math.PI * 1);
		d13mesh.rotateZ(Math.PI * 0.5);
		d13mesh.position.set(-200, 400 , -930);		
		threeHCSR.add(d13mesh);			
		
		//sferacopritubo
		const sphereGeometry = new THREE.SphereGeometry(30, 30, 30);
		const d14mesh = new THREE.Mesh(sphereGeometry, dmaterial);
		d14mesh.position.set(-430, 400 , -930);		
		threeHCSR.add(d14mesh);			
		
		//up3
		const udgeometry2g = new THREE.CylinderGeometry(50, 50, 100, 25);
		const d15mesh = new THREE.Mesh(udgeometry2g, dmaterial);
		d15mesh.rotateX(Math.PI * 0.5);
		d15mesh.rotateY(Math.PI * 1);
		d15mesh.rotateZ(Math.PI * 1);
		d15mesh.position.set(0, 650 , -700);		
		threeHCSR.add(d15mesh);	
		
		
		//up3a
		const udgeometry2h = new THREE.CylinderGeometry(30, 30, 400, 25);
		const d16mesh = new THREE.Mesh(udgeometry2h, dmaterial);
		d16mesh.rotateX(Math.PI * 0.5);
		d16mesh.rotateY(Math.PI * 1);
		d16mesh.rotateZ(Math.PI * 1);
		d16mesh.position.set(0, 650 , -900);		
		threeHCSR.add(d16mesh);		
		
		//up3b
		const udgeometry2l = new THREE.CylinderGeometry(30, 30, 400, 25);
		const d17mesh = new THREE.Mesh(udgeometry2l, dmaterial);
		d17mesh.rotateX(Math.PI * 0.5);
		d17mesh.rotateY(Math.PI * 1);
		d17mesh.rotateZ(Math.PI * 1);
		d17mesh.position.set(0, 650 , -900);		
		threeHCSR.add(d16mesh);				
		
		//up3c
		const udgeometry2m = new THREE.CylinderGeometry(30, 30, 400, 25);
		const d18mesh = new THREE.Mesh(udgeometry2m, dmaterial);
		d18mesh.rotateX(Math.PI * 0.5);
		d18mesh.rotateY(Math.PI * 0.75);
		d18mesh.rotateZ(Math.PI * 1.5);
		d18mesh.position.set(-140, 790 , -1100);		
		threeHCSR.add(d18mesh);			
 
		//sferacopritubo laterale
		const sphereGeometry2 = new THREE.SphereGeometry(30, 30, 30);
		const d19mesh = new THREE.Mesh(sphereGeometry2, dmaterial);
		d19mesh.position.set(0, 650 , -1100);		
		threeHCSR.add(d19mesh);			
		
		//tubilaterali1
		const lateraltube1 = new THREE.CylinderGeometry(180, 180, 100, 25);
		const d20mesh = new THREE.Mesh(lateraltube1, dmaterial);
		d20mesh.rotateX(Math.PI * 0.5);
		d20mesh.rotateY(Math.PI * 1);
		d20mesh.rotateZ(Math.PI * 0.5);
		d20mesh.position.set(-700, -400 , 0);		
		threeHCSR.add(d20mesh);

		//tubilaterali1a
		const lateraltube1a = new THREE.CylinderGeometry(120, 120, 200, 25);
		const d21mesh = new THREE.Mesh(lateraltube1a, dmaterial);
		d21mesh.rotateX(Math.PI * 0.5);
		d21mesh.rotateY(Math.PI * 1);
		d21mesh.rotateZ(Math.PI * 0.5);
		d21mesh.position.set(-800, -400 , 0);		
		threeHCSR.add(d21mesh);		
		
		//cubo1
		const cube1 = new THREE.BoxGeometry(240, 240, 240);
		const d22mesh = new THREE.Mesh(cube1, dmaterial);
		d22mesh.position.set(-1000, -400 , 0);
		threeHCSR.add(d22mesh);	
		
		//cubo2 red
		const cube2 = new THREE.BoxGeometry(190, 190, 190);
		const cubematerial = new THREE.MeshLambertMaterial({color: 0xFF0000});
		const d23mesh = new THREE.Mesh(cube2, cubematerial);
		d23mesh.position.set(-1000, -400 , -50);
		threeHCSR.add(d23mesh);	
		
		//tubilaterali2a
		const lateraltube2a = new THREE.CylinderGeometry(140, 140, 200, 25);
		const d24mesh = new THREE.Mesh(lateraltube2a, dmaterial);
		d24mesh.rotateX(Math.PI * 0.5);
		d24mesh.rotateY(Math.PI * 1);
		d24mesh.rotateZ(Math.PI * 0.5);
		d24mesh.position.set(-650, 0 , 0);		
		threeHCSR.add(d24mesh);		
		
		//tubilaterali2b
		const lateraltube2b = new THREE.CylinderGeometry(180, 180, 50, 25);
		const d25mesh = new THREE.Mesh(lateraltube2b, dmaterial);
		d25mesh.rotateX(Math.PI * 0.5);
		d25mesh.rotateY(Math.PI * 1);
		d25mesh.rotateZ(Math.PI * 0.5);
		d25mesh.position.set(-770, 0 , 0);		
		threeHCSR.add(d25mesh);		
		
		//tubilaterali3a
		const lateraltube3a = new THREE.CylinderGeometry(180, 180, 110, 25);
		const d26mesh = new THREE.Mesh(lateraltube3a, dmaterial);
		d26mesh.rotateX(Math.PI * 0.5);
		d26mesh.rotateY(Math.PI * 1);
		d26mesh.rotateZ(Math.PI * 0.5);
		d26mesh.position.set(-680, 520 , -200);	
		threeHCSR.add(d26mesh);			
		
		//bulloni front
		const bulloni1 = new THREE.CylinderGeometry(10, 10, 10, 8);
		const d27mesh = new THREE.Mesh(bulloni1, dmaterial2);
		d27mesh.rotateX(Math.PI * 0.5);
		d27mesh.rotateY(Math.PI * 1);
		d27mesh.rotateZ(Math.PI * 0.5);
		d27mesh.position.set(-800,100,-120);
		const bolt = new THREE.Object3D();
		const bolts = new THREE.Object3D();
		bolt.add(d27mesh);	
		for (let i=-6; i<6; i++) {
			const bolt2 = bolt.clone();
			bolt2.rotateX(-Math.PI / 6*i);
			bolts.add(bolt2);
		}
		bolts.add(bolt);
		const bolts2 = bolts.clone();
		bolts2.position.set(60,520,-200);
		threeHCSR.add(bolts);	
		threeHCSR.add(bolts2);	
		
		threeHCSR.scale.set(0.7, 0.7, 0.7);
		
		return threeHCSR;
	}


	// scw
	export function scw(param) {
		const length = param && typeof param.length == "number"? param.length: 2200;
		const SCWSR = new THREE.Object3D();
		const dmaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		const dmaterial2 = new THREE.MeshLambertMaterial({color: 0xffffff});
		const d1geometry = new THREE.CylinderGeometry(700, 700, length, 35);
		const d1mesh = new THREE.Mesh(d1geometry, dmaterial);
		SCWSR.add(d1mesh);				
		SCWSR.rotateX(Math.PI * 0.5);
		SCWSR.rotatedX = true;	

		// left
		const lrgeometry = new THREE.CylinderGeometry(750, 750, 100, 65);
		const d2mesh = new THREE.Mesh(lrgeometry, dmaterial);
		d2mesh.position.set(0, -length/2-50, 0);
		SCWSR.add(d2mesh);
		
		// left center
		const lrgeometry2 = new THREE.CylinderGeometry(750, 750, 70, 65);
		const d2meshc = new THREE.Mesh(lrgeometry2, dmaterial);
		d2meshc.position.set(0, -length/2+800, 0);
		SCWSR.add(d2meshc);		

		// right
		const d3mesh = new THREE.Mesh(lrgeometry, dmaterial);
		d3mesh.position.set(0, length/2+50, 0);
		SCWSR.add(d3mesh);
		
		// right center
		const lrgeometry3 = new THREE.CylinderGeometry(750, 750, 70, 65);
		const d3meshc = new THREE.Mesh(lrgeometry3, dmaterial);
		d3meshc.position.set(0, -length/2+1400, 0);
		SCWSR.add(d3meshc);				

		// up1
		const udgeometry = new THREE.CylinderGeometry(200, 200, 300, 25);
		const d4mesh = new THREE.Mesh(udgeometry, dmaterial);
		d4mesh.rotateX(Math.PI * 0.5);
		d4mesh.rotateY(Math.PI * 1);
		d4mesh.rotateZ(Math.PI * 1);
		d4mesh.position.set(0, -600 , -770);		
		SCWSR.add(d4mesh);

		// up2
		const udgeometry2 = new THREE.CylinderGeometry(200, 200, 300, 25);
		const d5mesh = new THREE.Mesh(udgeometry2, dmaterial);
		d5mesh.rotateX(Math.PI * 0.5);
		d5mesh.rotateY(Math.PI * 1);
		d5mesh.rotateZ(Math.PI * 1);
		d5mesh.position.set(0, 0 , -730);		
		SCWSR.add(d5mesh);



		//up3
		const udgeometry2g = new THREE.CylinderGeometry(200, 200, 300, 25);
		const d6mesh = new THREE.Mesh(udgeometry2g, dmaterial);
		d6mesh.rotateX(Math.PI * 0.5);
		d6mesh.rotateY(Math.PI * 1);
		d6mesh.rotateZ(Math.PI * 1);
		d6mesh.position.set(0, 600 , -730);		
		SCWSR.add(d6mesh);	
		
		//cubo1
		const cube1 = new THREE.BoxGeometry(150, 150, 150);
		const d7mesh = new THREE.Mesh(cube1, dmaterial2);
		d7mesh.position.set(-610, 0 , -200);
		SCWSR.add(d7mesh);	
		
			
		// up1b
		const udgeometryb = new THREE.CylinderGeometry(250, 250, 100, 25);
		const d9mesh = new THREE.Mesh(udgeometryb, dmaterial);
		d9mesh.rotateX(Math.PI * 0.5);
		d9mesh.rotateY(Math.PI * 1);
		d9mesh.rotateZ(Math.PI * 1);
		d9mesh.position.set(0, -600 , -900);		
		SCWSR.add(d9mesh);	
		
		// up1c
		const udgeometryc = new THREE.CylinderGeometry(200, 200, 300, 25);
		const d10mesh = new THREE.Mesh(udgeometryc, dmaterial);
		d10mesh.rotateX(Math.PI * 0.5);
		d10mesh.rotateY(Math.PI * 1);
		d10mesh.rotateZ(Math.PI * 1);
		d10mesh.position.set(0, -600 , -1100);		
		SCWSR.add(d10mesh);	
		
		// up1d
		const udgeometrye = new THREE.CylinderGeometry(250, 250, 100, 25);
		const d11mesh = new THREE.Mesh(udgeometryb, dmaterial);
		d11mesh.rotateX(Math.PI * 0.5);
		d11mesh.rotateY(Math.PI * 1);
		d11mesh.rotateZ(Math.PI * 1);
		d11mesh.position.set(0, -600 , -1300);		
		SCWSR.add(d11mesh);	
		
		// up2b
		const d12mesh = new THREE.Mesh(udgeometryb, dmaterial);
		d12mesh.rotateX(Math.PI * 0.5);
		d12mesh.rotateY(Math.PI * 1);
		d12mesh.rotateZ(Math.PI * 1);
		d12mesh.position.set(0, 0 , -900);		
		SCWSR.add(d12mesh);			
		
		// up2c
		const d13mesh = new THREE.Mesh(udgeometryc, dmaterial);
		d13mesh.rotateX(Math.PI * 0.5);
		d13mesh.rotateY(Math.PI * 1);
		d13mesh.rotateZ(Math.PI * 1);
		d13mesh.position.set(0, 0 , -900);		
		SCWSR.add(d13mesh);			

		// up2d
		const d14mesh = new THREE.Mesh(udgeometryb, dmaterial);
		d14mesh.rotateX(Math.PI * 0.5);
		d14mesh.rotateY(Math.PI * 1);
		d14mesh.rotateZ(Math.PI * 1);
		d14mesh.position.set(0, 0 , -1090);		
		SCWSR.add(d14mesh);	
		
		// up3b
		const d15mesh = new THREE.Mesh(udgeometryb, dmaterial);
		d15mesh.rotateX(Math.PI * 0.5);
		d15mesh.rotateY(Math.PI * 1);
		d15mesh.rotateZ(Math.PI * 1);
		d15mesh.position.set(0, 600 , -900);		
		SCWSR.add(d15mesh);	
		
		// up3c
		const d16mesh = new THREE.Mesh(udgeometryc, dmaterial);
		d16mesh.rotateX(Math.PI * 0.5);
		d16mesh.rotateY(Math.PI * 1);
		d16mesh.rotateZ(Math.PI * 1);
		d16mesh.position.set(0, 600 , -1100);		
		SCWSR.add(d16mesh);		
		
		// up3d
		const d17mesh = new THREE.Mesh(udgeometryb, dmaterial);
		d17mesh.rotateX(Math.PI * 0.5);
		d17mesh.rotateY(Math.PI * 1);
		d17mesh.rotateZ(Math.PI * 1);
		d17mesh.position.set(0, 600 , -1300);		
		SCWSR.add(d17mesh);
		
		SCWSR.scale.set(0.7, 0.7, 0.7);
		
		return SCWSR;
	}
	// lmbf
		export function lmbf(param) {
			const length=300;
			const lmbfSR = new THREE.Object3D();
			const lmbfContainer = new THREE.Object3D();
			
			const dmaterial = new THREE.MeshLambertMaterial({color: 0xc0c0c0});
			const dmaterial2 = new THREE.MeshLambertMaterial({color: 0x969696});
			
			const d1geometry = new THREE.CylinderGeometry(100, 100, 250, 25);
			const d1mesh = new THREE.Mesh(d1geometry, dmaterial);
			d1mesh.position.set(0, 0, 0);
			lmbfContainer.add(d1mesh);				
			lmbfContainer.rotateX(Math.PI * 0.5);
			lmbfContainer.rotatedX = true;	

			// left
			const d2geometry = new THREE.CylinderGeometry(100, 100, 10, 25);
			const d2mesh = new THREE.Mesh(d2geometry, dmaterial2);
			d2mesh.position.set(0, -130, 0);
			lmbfContainer.add(d2mesh);

			// right
			const d3geometry = new THREE.CylinderGeometry(100, 100, 10, 25);
			const d3mesh = new THREE.Mesh(d3geometry, dmaterial2);
			d3mesh.position.set(0, 130, 0);
			lmbfContainer.add(d3mesh);

			// up1
			const d4geometry = new THREE.CylinderGeometry(10, 10, 250, 25);
			const d4mesh = new THREE.Mesh(d4geometry, dmaterial2);
			d4mesh.rotateX(Math.PI * 0.5);
			d4mesh.rotateY(Math.PI * 1);
			d4mesh.rotateZ(Math.PI * 1);
			d4mesh.position.set(0, -80 , 0);		
			lmbfContainer.add(d4mesh);

			// up2
			const d5geometry = new THREE.CylinderGeometry(10, 10, 250, 25);
			const d5mesh = new THREE.Mesh(d5geometry, dmaterial2);
			d5mesh.rotateX(Math.PI * 0.5);
			d5mesh.rotateY(Math.PI * 1);
			d5mesh.rotateZ(Math.PI * 1);
			d5mesh.position.set(0, 80 , 0);		
			lmbfContainer.add(d5mesh);
			
			// lef1
			const d6geometry = new THREE.CylinderGeometry(10, 10, 250, 25);
			const d6mesh = new THREE.Mesh(d6geometry, dmaterial2);
			d6mesh.rotateX(Math.PI * 0.5);
			d6mesh.rotateY(Math.PI * 1);
			d6mesh.rotateZ(Math.PI * 0.5);
			d6mesh.position.set(0, -80 , 0);		
			lmbfContainer.add(d6mesh);

			// right2
			const d7geometry = new THREE.CylinderGeometry(10, 10, 250, 25);
			const d7mesh = new THREE.Mesh(d7geometry, dmaterial2);
			d7mesh.rotateX(Math.PI * 0.5);
			d7mesh.rotateY(Math.PI * 1);
			d7mesh.rotateZ(Math.PI * 0.5);
			d7mesh.position.set(0, 80 , 0);		
			lmbfContainer.add(d7mesh);			
			
			lmbfContainer.position.set(0, 0, 0);
		    lmbfSR.add(lmbfContainer);
		    lmbfSR.rotateY(Math.PI * 1);
			return lmbfSR;
		}
	// tmbf
		export function tmbf(param) {
			const length=600;
			const tmbfSR = new THREE.Object3D();
			const tmbfContainer = new THREE.Object3D();
			
			const dmaterial = new THREE.MeshLambertMaterial({color: 0xffd700});
			const dmaterial2 = new THREE.MeshLambertMaterial({color: 0x969696});
			const dmaterialsilver = new THREE.MeshLambertMaterial({color: 0xc0c0c0});
			
			const d1geometry = new THREE.CylinderGeometry(100, 100, 600, 25);
			const d1mesh = new THREE.Mesh(d1geometry, dmaterial);
			d1mesh.position.set(0, 0, 0);
			tmbfContainer.add(d1mesh);				
			tmbfContainer.rotateX(Math.PI * 0.5);
			tmbfContainer.rotatedX = true;	

			// coverleft
			const d2geometry = new THREE.CylinderGeometry(130, 130, 20, 25);
			const d2mesh = new THREE.Mesh(d2geometry, dmaterial);
			d2mesh.position.set(0, -300, 0);
			tmbfContainer.add(d2mesh);
			
			// coverleft silver
			const dslgeometry = new THREE.CylinderGeometry(130, 130, 20, 25);
			const dslmesh = new THREE.Mesh(dslgeometry, dmaterialsilver);
			dslmesh.position.set(0, -320, 0);
			tmbfContainer.add(dslmesh);			

			//covercenter
			const dmgeometry = new THREE.CylinderGeometry(130, 130, 40, 25);
			const dmmesh = new THREE.Mesh(dmgeometry, dmaterial);
			dmmesh.position.set(0, 0, 0);
			tmbfContainer.add(dmmesh);			
			
			//coverright
			const d3geometry = new THREE.CylinderGeometry(130, 130, 20, 25);
			const d3mesh = new THREE.Mesh(d3geometry, dmaterial);
			d3mesh.position.set(0, 300, 0);
			tmbfContainer.add(d3mesh);
			
			// coverright silver
			const dsrgeometry = new THREE.CylinderGeometry(130, 130, 20, 25);
			const dsrmesh = new THREE.Mesh(dsrgeometry, dmaterialsilver);
			dsrmesh.position.set(0, 320, 0);
			tmbfContainer.add(dsrmesh);				

			// up1
			const d4geometry = new THREE.CylinderGeometry(10, 10, 250, 25);
			const d4mesh = new THREE.Mesh(d4geometry, dmaterial2);
			d4mesh.rotateX(Math.PI * 0.5);
			d4mesh.rotateY(Math.PI * 1);
			d4mesh.rotateZ(Math.PI * 1);
			d4mesh.position.set(0, -80 , 0);		
			tmbfContainer.add(d4mesh);

			// up2
			const d5geometry = new THREE.CylinderGeometry(10, 10, 250, 25);
			const d5mesh = new THREE.Mesh(d5geometry, dmaterial2);
			d5mesh.rotateX(Math.PI * 0.5);
			d5mesh.rotateY(Math.PI * 1);
			d5mesh.rotateZ(Math.PI * 1);
			d5mesh.position.set(0, -200 , 0);		
			tmbfContainer.add(d5mesh);
			
			// lef1
			const d6geometry = new THREE.CylinderGeometry(10, 10, 250, 25);
			const d6mesh = new THREE.Mesh(d6geometry, dmaterial2);
			d6mesh.rotateX(Math.PI * 0.5);
			d6mesh.rotateY(Math.PI * 1);
			d6mesh.rotateZ(Math.PI * 0.5);
			d6mesh.position.set(0, 80 , 0);		
			tmbfContainer.add(d6mesh);

			// right2
			const d7geometry = new THREE.CylinderGeometry(10, 10, 250, 25);
			const d7mesh = new THREE.Mesh(d7geometry, dmaterial2);
			d7mesh.rotateX(Math.PI * 0.5);
			d7mesh.rotateY(Math.PI * 1);
			d7mesh.rotateZ(Math.PI * 0.5);
			d7mesh.position.set(0, 200 , 0);		
			tmbfContainer.add(d7mesh);			
			
			tmbfContainer.position.set(0, 0, 0);
		    tmbfSR.add(tmbfContainer);
		    tmbfSR.rotateY(Math.PI * 1);
			return tmbfSR;
		}
	// scraper
	export function scraper(param) {
		const ScraperContiner = new THREE.Object3D();
		const ScraperObject = new THREE.Object3D();
		
		// box esterno
		const boxmaterial = new THREE.MeshLambertMaterial({color: 0xd6d6d6});
		const boxgeometry = new THREE.BoxGeometry(140, 40, 400);
		const d1mesh = new THREE.Mesh(boxgeometry, boxmaterial);
		d1mesh.position.set(0, 0, 0);
		d1mesh.rotateX(Math.PI * 1.250);
		d1mesh.rotateY(Math.PI * 1.5);
		d1mesh.rotateZ(Math.PI * 1.25);	
		d1mesh.position.set(0, 0, 0);
		ScraperObject.add(d1mesh);
		
		// box lato1
		const sidematerial2 = new THREE.MeshLambertMaterial({color: 0xd6d6d6});
		const sidegeometry2 = new THREE.BoxGeometry(140, 20, 140 );
		const d2mesh = new THREE.Mesh(sidegeometry2, sidematerial2);
		d2mesh.position.set(0, 0, 0);
		d2mesh.rotateX(Math.PI * 1.5);
		d2mesh.rotateY(Math.PI * 1);
		d2mesh.rotateZ(Math.PI * 1.5);	
		d2mesh.position.set(-191, 50, 0);
		ScraperObject.add(d2mesh);		
		
		// box lato2
		const sidematerial3 = new THREE.MeshLambertMaterial({color: 0xd6d6d6});
		const sidegeometry3 = new THREE.BoxGeometry(140, 20, 140 );
		const d3mesh = new THREE.Mesh(sidegeometry3, sidematerial3);
		d3mesh.position.set(0, 0, 0);
		d3mesh.rotateX(Math.PI * 1.5);
		d3mesh.rotateY(Math.PI * 1);
		d3mesh.rotateZ(Math.PI * 1.5);	
		d3mesh.position.set(191, 50, 0);
		ScraperObject.add(d3mesh);		
		
		// box esterno2
		const boxgeometry2 = new THREE.BoxGeometry(140, 40, 400);
		const d5mesh = new THREE.Mesh(boxgeometry2, boxmaterial);
		d5mesh.position.set(0, 0, 0);
		d5mesh.rotateX(Math.PI * 1.250);
		d5mesh.rotateY(Math.PI * 1.5);
		d5mesh.rotateZ(Math.PI * 1.25);	
		d5mesh.position.set(0, 100, 0);
		ScraperObject.add(d5mesh);		
		
		//cilinder
		const cilgeometry = new THREE.CylinderGeometry(50, 50, 340, 25);
		const cilmaterial = new THREE.MeshLambertMaterial({color: 0xc4c4c4});
		const d4mesh = new THREE.Mesh(cilgeometry, cilmaterial);
		d4mesh.rotateX(Math.PI * 1);
		d4mesh.rotateY(Math.PI * 1.5);
		d4mesh.rotateZ(Math.PI * 1.5);
		d4mesh.position.set(0,50 , 0);			
		ScraperObject.add(d4mesh);	
		
		//cilinder2
		const cilgeometry2 = new THREE.CylinderGeometry(15, 15, 360, 15);
		const d6mesh = new THREE.Mesh(cilgeometry2, cilmaterial);
		d6mesh.rotateX(Math.PI * 1);
		d6mesh.rotateY(Math.PI * 1.0);
		d6mesh.rotateZ(Math.PI * 1.5);
		d6mesh.position.set(0,50 , 0);			
		ScraperObject.add(d6mesh);				
		
		ScraperObject.position.set(0, -150, 0);
		ScraperObject.scale.setX(3);
		ScraperObject.scale.setY(3);
		ScraperObject.scale.setZ(1);
		ScraperContiner.add(ScraperObject);
		ScraperContiner.rotateY(Math.PI * -1);		
		
		
		return ScraperContiner;
	}
	// valve
	export function vlv(param) {
		const vlvContiner = new THREE.Object3D();
		const vlvObject = new THREE.Object3D();
		
		//cylinder
		const cylgeometry = new THREE.CylinderGeometry(25, 25, 50, 15);
		const cylmaterial = new THREE.MeshLambertMaterial({color: 0xc7c7c7});
		const cylmesh = new THREE.Mesh(cylgeometry, cylmaterial);
		cylmesh.rotateX(Math.PI * 1);
		cylmesh.rotateY(Math.PI * 1.0);
		cylmesh.rotateZ(Math.PI * 1.5);
		cylmesh.position.set(0, 0 , 0);			
		vlvObject.add(cylmesh);			
		
		// base1
		const vlvgeometry = new THREE.BoxGeometry(30, 160, 60 );
		const vlvmaterial = new THREE.MeshLambertMaterial({color: 0xc7c7c7});		
		const vlv1mesh = new THREE.Mesh(vlvgeometry, vlvmaterial);
		vlv1mesh.position.set(0, 50, 0);
		vlv1mesh.colorable = true;
		vlvObject.add(vlv1mesh);		
		
		// hat1
		const hatmaterial = new THREE.MeshLambertMaterial({color: 0xc7c7c7});
		const hatgeometry = new THREE.BoxGeometry(50, 20, 100 );
		const hatmesh = new THREE.Mesh(hatgeometry, hatmaterial);
		hatmesh.colorable = true;
		hatmesh.position.set(0, 120, 0);
		vlvObject.add(hatmesh);	
		
		// blackbox
		const blackboxmaterial = new THREE.MeshLambertMaterial({color: 0x636363});
		const blackboxgeometry = new THREE.BoxGeometry(40, 70, 70 );
		const blackboxmesh = new THREE.Mesh(blackboxgeometry, blackboxmaterial);
		blackboxmesh.position.set(0, 165, 15);
		vlvObject.add(blackboxmesh);
		
		// blackbox2
		const blackbox2material = new THREE.MeshLambertMaterial({color: 0x000000});
		const blackbox2geometry = new THREE.BoxGeometry(40, 40, 20 );
		const blackbo2xmesh = new THREE.Mesh(blackbox2geometry, blackbox2material);
		blackbo2xmesh.position.set(0, 165, -30);
		vlvObject.add(blackbo2xmesh);			
		vlvObject.scale.setX(1.5);
		vlvObject.scale.setY(1.5);
		vlvObject.scale.setZ(1.5);	
		
		//TRIANGLE1
		const trianglegeometry = new THREE.CylinderGeometry(18, 18, 32, 3);
		const trianglegeometrymesh = new THREE.Mesh(trianglegeometry, blackbox2material);
		trianglegeometrymesh.rotateX(Math.PI * 0);
		trianglegeometrymesh.rotateY(Math.PI * 0);
		trianglegeometrymesh.rotateZ(Math.PI * 0.5);		
		trianglegeometrymesh.position.set(0, 60 , -17);		
		vlvObject.add(trianglegeometrymesh);	
		
		//TRIANGLE2
		const trianglegeometry2 = new THREE.CylinderGeometry(18, 18, 32, 3);
		const triangle2geometrymesh = new THREE.Mesh(trianglegeometry2, blackbox2material);
		triangle2geometrymesh.rotateX(Math.PI * 0);
		triangle2geometrymesh.rotateY(Math.PI * 1);
		triangle2geometrymesh.rotateZ(Math.PI * 0.5);		
		triangle2geometrymesh.position.set(0, 60 ,17);		
		vlvObject.add(triangle2geometrymesh);		
		
		vlvObject.position.set(0, 0, 0);
		vlvObject.rotateY(Math.PI * -0.5);
		vlvContiner.add(vlvObject);

		return vlvContiner;
	}
	export function vlvUpdate(c, color) {
		const vlv = c.children[0].children;
		for (let i=0; i<vlv.length; i++) {
			if (vlv[i].colorable) {
				vlv[i].material.dispose();
				vlv[i].material = new THREE.MeshLambertMaterial({color: color});
			}
		}
	}
	// bst
	export function bst(param) {
		const bstObject = new THREE.Object3D();
		const bstContiner = new THREE.Object3D();
		const materialGrey = new THREE.MeshLambertMaterial({color: 0xc0c0c0});

		const d1geometry = new THREE.CylinderGeometry(25, 25, 200, 25);
		const d1mesh = new THREE.Mesh(d1geometry, materialGrey);
		d1mesh.position.set(0, 190, 0);
		bstObject.add(d1mesh);
		bstObject.rotateX(Math.PI * 1);

		// circ base
		const d2geometry = new THREE.CylinderGeometry(50, 50, 80, 15);
		const d2mesh = new THREE.Mesh(d2geometry, materialGrey);
		d2mesh.position.set(0, 290, 0);
		d2mesh.rotateX(Math.PI * 1);
		d2mesh.rotateY(Math.PI * 1);
		d2mesh.rotateZ(Math.PI * 1.5);		
		bstObject.add(d2mesh);

		// zigrinatura
		const d4geometry = new THREE.CylinderGeometry(40, 40, 120, 15);
		const textureLoader = new THREE.TextureLoader();
		const texture = textureLoader.load('./components/flsc_texture.png');
		texture.wrapS = texture.wrapT = THREE.RepeatWrapping;
		texture.repeat.set(5, 40);
		const material = new THREE.MeshBasicMaterial({ map: texture });
		const d4mesh = new THREE.Mesh(d4geometry, material);
		d4mesh.rotateX(Math.PI * 1);
		d4mesh.rotateY(Math.PI * 1);
		d4mesh.rotateZ(Math.PI * 1);
		d4mesh.position.set(0, 120 , 0);
		bstObject.add(d4mesh);

		// cil Major
		const d5geometry = new THREE.CylinderGeometry(90, 90, 20, 15);
		const d5mesh = new THREE.Mesh(d5geometry, materialGrey);
		d5mesh.rotateX(Math.PI * 1);
		d5mesh.rotateY(Math.PI * 1);
		d5mesh.rotateZ(Math.PI * 1);
		d5mesh.position.set(0, 50 , 0);
		d5mesh.colorable = true;
		bstObject.add(d5mesh);

		// cil Med
		const d6geometry = new THREE.CylinderGeometry(70, 70, 80, 15);
		const d6mesh = new THREE.Mesh(d6geometry, materialGrey);
		d6mesh.rotateX(Math.PI * 1);
		d6mesh.rotateY(Math.PI * 1);
		d6mesh.rotateZ(Math.PI * 1);
		d6mesh.position.set(0, 0 , 0);
		d6mesh.colorable = true;
		bstObject.add(d6mesh);

		// cil low
		const d7geometry = new THREE.CylinderGeometry(50, 50, 120, 15);
		const d7mesh = new THREE.Mesh(d7geometry, materialGrey);
		d7mesh.rotateX(Math.PI * 1);
		d7mesh.rotateY(Math.PI * 1);
		d7mesh.rotateZ(Math.PI * 1);
		d7mesh.position.set(0, -100 , 0);
		d7mesh.colorable = true;
		bstObject.add(d7mesh);

		const d8geometry = new THREE.CylinderGeometry(60, 60, 20, 15);
		const d8mesh = new THREE.Mesh(d8geometry, materialGrey);
		d8mesh.rotateX(Math.PI * 1);
		d8mesh.rotateY(Math.PI * 1);
		d8mesh.rotateZ(Math.PI * 1);
		d8mesh.position.set(0, -170 , 0);
		bstObject.add(d8mesh);

		bstObject.position.set(0, 290, 0);
		bstContiner.add(bstObject);
		bstContiner.rotateY(Math.PI * -0.5);
		return bstContiner;
	}
	export function bstUpdate(c, color) {
		const vlv = c.children[0].children;
		for (let i=0; i<vlv.length; i++) {
			if (vlv[i].colorable) {
				vlv[i].material.dispose();
				vlv[i].material = new THREE.MeshLambertMaterial({color: color});
			}
		}
	}
	// BeamlinesUP
	export function beamlineUp(param) {
		// console.log('beamlineUp()',param);
		const continer = new THREE.Object3D();
		const text=param.name, height=50;
		let length = param && param.labelReverse && param.labelReverse[1]? param.labelReverse[1]: 200;
		const depth = param && param.labelReverse && param.labelReverse[2]? param.labelReverse[2]: 18000*(param.labelReverse? -1: 1);
		let size=500;
		const materialBase = new THREE.MeshLambertMaterial({color: 0xff0000});
		const objLabel = new THREE.Object3D();
		let group, textMesh, textGeo, materials;
		let textheight = 50;
		let pos = [];
		let rot = [];
		const hover = 30;
		const curveSegments = 8;
		let font;
		function insertText(isize, ipos, irot) {
			group = new THREE.Group();
			objLabel.add( group );
			size = isize;
			pos = ipos;
			rot = irot;
			loadFont();
		}
		function loadFont() {
			const loader = new FontLoader();
			// https://threejs.org/examples/fonts/droid_sans_bold.typeface.json
			loader.load( './fonts/droid_sans_bold.typeface.json', function ( response ) {
				font = response;
				refreshText();
			} );
		}
		function createText() {
			textGeo = new TextGeometry(text, {font: font, size: size, height: textheight, curveSegments: curveSegments});
			textGeo.computeBoundingBox();
			const centerOffset = - 0.5 * ( textGeo.boundingBox.max.x - textGeo.boundingBox.min.x );
			textMesh = new THREE.Mesh( textGeo, materialBase );
			textMesh.position.x = pos[0];
			textMesh.position.y = pos[1];
			textMesh.position.z = pos[2];
			textMesh.rotation.x = rot[0];
			textMesh.rotation.y = rot[1];
			textMesh.rotation.z = rot[2];
			group.add( textMesh );
		}
		function refreshText() {
			group.remove( textMesh );
			if ( ! text ) return;
			createText();
		}
		insertText(size, [length, height, depth], [Math.PI*0.5, Math.PI, Math.PI*0.5]);
		continer.add(objLabel);
		length=30000;
		const material = new THREE.MeshBasicMaterial({color: 0x00e9ff, transparent: true, opacity: 0.4, side: THREE.DoubleSide});
		const geometry = new THREE.CylinderGeometry(1500*(param.labelReverse? 0: 1) /*radiusTop*/, 1500*(param.labelReverse? 1: 0) /*radiusBottom*/, length /*height*/, 2 /*radialSegments*/, 2 /*heightSegments*/, true /*openEnded*/,0 /*thetaStart*/, Math.PI * 0.5 /*thetaLength*/);
		const beamlineUpMesh = new THREE.Mesh(geometry, material);
		beamlineUpMesh.position.set(0, 0, length/2*(param.labelReverse? -1: 1));	
		beamlineUpMesh.rotateX(Math.PI * 0.5);
		beamlineUpMesh.rotateY(Math.PI * 0.5);
		beamlineUpMesh.scale.setX(0.001);
		continer.add(beamlineUpMesh);
		return continer;
	}
	// BeamlinesDown
	export function beamlineDown(param) {
		// console.log('beamlineDown()',param);
		const continer = new THREE.Object3D();
		const text=param.name, height=50;
		let length = param && param.labelReverse && param.labelReverse[1]? param.labelReverse[1]: -700;
		const depth = param && param.labelReverse && param.labelReverse[2]? param.labelReverse[2]: 18000*(param.labelReverse? -1: 1);
		let size=500;
		const materialBase = new THREE.MeshLambertMaterial({color: 0xff0000});
		const objLabel = new THREE.Object3D();
		let group, textMesh, textGeo, materials;
		let textheight = 50;
		let pos = [];
		let rot = [];
		const hover = 30;
		const curveSegments = 8;
		let font;
		function insertText(isize, ipos, irot) {
			group = new THREE.Group();
			objLabel.add( group );
			size = isize;
			pos = ipos;
			rot = irot;
			loadFont();
		}
		function loadFont() {
			const loader = new FontLoader();
			// https://threejs.org/examples/fonts/droid_sans_bold.typeface.json
			loader.load( './fonts/droid_sans_bold.typeface.json', function ( response ) {
				font = response;
				refreshText();
			} );
		}
		function createText() {
			textGeo = new TextGeometry(text, {font: font, size: size, height: textheight, curveSegments: curveSegments});
			textGeo.computeBoundingBox();
			const centerOffset = - 0.5 * ( textGeo.boundingBox.max.x - textGeo.boundingBox.min.x );
			textMesh = new THREE.Mesh( textGeo, materialBase );
			textMesh.position.x = pos[0];
			textMesh.position.y = pos[1];
			textMesh.position.z = pos[2];
			textMesh.rotation.x = rot[0];
			textMesh.rotation.y = rot[1];
			textMesh.rotation.z = rot[2];
			group.add( textMesh );
		}
		function refreshText() {
			group.remove( textMesh );
			if ( ! text ) return;
			createText();
		}
		insertText(size, [length, height, depth], [Math.PI*0.5, Math.PI, Math.PI*0.5]);
		continer.add(objLabel);
		length=30000;
		const material = new THREE.MeshBasicMaterial({color: 0xd000ff, transparent: true, opacity: 0.2, side: THREE.DoubleSide});
		const geometry = new THREE.CylinderGeometry(1500*(param.labelReverse? 0: 1) /*radiusTop*/, 1500*(param.labelReverse? 1: 0) /*radiusBottom*/, length /*height*/, 2 /*radialSegments*/, 2 /*heightSegments*/, true /*openEnded*/,Math.PI /*thetaStart*/, Math.PI * 0.5 /*thetaLength*/);
		const beamlineUpMesh = new THREE.Mesh(geometry, material);
		beamlineUpMesh.position.set(0, 0, length/2*(param.labelReverse? -1: 1));	
		beamlineUpMesh.rotateX(Math.PI * 0.5);
		beamlineUpMesh.rotateY(Math.PI * 0.5);
		beamlineUpMesh.scale.setX(0.001);
		continer.add(beamlineUpMesh);
		return continer;
	}
	// PLC
	export function plc(param) {
		const plcObject = new THREE.Object3D();
		const cardsObject = new THREE.Object3D();
		
	
		const greenmaterial = new THREE.MeshLambertMaterial({color: 0x00ff11});
		const greenDarkmaterial = new THREE.MeshLambertMaterial({color: 0x0b5e11});
		const graymaterial = new THREE.MeshLambertMaterial({color: 0x575757});
		const graymaterial2 = new THREE.MeshLambertMaterial({color: 0x7d7d7d});
		const silvermaterial = new THREE.MeshLambertMaterial({color: 0xa6a6a6});
		const blackmaterial = new THREE.MeshLambertMaterial({color: 0x000000});

		
		// base
		const basegeometry = new THREE.BoxGeometry(500, 300, 600);
		const basegeometrymesh = new THREE.Mesh(basegeometry, silvermaterial);
		basegeometrymesh.position.set( 0, 0 ,0);
		plcObject.add(basegeometrymesh);	
		
		// card
		const cardgeometry = new THREE.BoxGeometry(502, 270, 50);
		const cardgeometrymesh = new THREE.Mesh(cardgeometry, blackmaterial);
		cardgeometrymesh.position.set( 0, 0 , -200);
		cardsObject.add(cardgeometrymesh);
		
		//led1
		const led1green = new THREE.BoxGeometry(504, 20, 20);
		const led1greenmesh = new THREE.Mesh(led1green, greenmaterial);
		led1greenmesh.position.set( 0, 120 , -200);
		cardsObject.add(led1greenmesh);		
		//led2
		const led2green = new THREE.BoxGeometry(504, 20, 20);
		const led2greenmesh = new THREE.Mesh(led2green, greenmaterial);
		led2greenmesh.position.set( 0, 90 , -200);
		cardsObject.add(led2greenmesh);
		//led3
		const led3green = new THREE.BoxGeometry(504, 20, 20);
		const led3greenmesh = new THREE.Mesh(led3green, greenmaterial);
		led3greenmesh.position.set( 0, 60 , -200);
		cardsObject.add(led3greenmesh);
		//led4
		const led4green = new THREE.BoxGeometry(504, 20, 20);
		const led4greenmesh = new THREE.Mesh(led4green, greenmaterial);
		led4greenmesh.position.set( 0, 30 , -200);
		cardsObject.add(led4greenmesh);
		//led5
		const led5green = new THREE.BoxGeometry(504, 20, 20);
		const led5greenmesh = new THREE.Mesh(led5green, greenDarkmaterial);
		led5greenmesh.position.set( 0, 0 , -200);
		cardsObject.add(led5greenmesh);			
		//led6
		const led6green = new THREE.BoxGeometry(504, 20, 20);
		const led6greenmesh = new THREE.Mesh(led6green, greenDarkmaterial);
		led6greenmesh.position.set( 0, -30 , -200);
		cardsObject.add(led6greenmesh);
		//led7
		const led7green = new THREE.BoxGeometry(504, 20, 20);
		const led7greenmesh = new THREE.Mesh(led7green, greenDarkmaterial);
		led7greenmesh.position.set( 0, -60 , -200);
		cardsObject.add(led7greenmesh);		
		//led8
		const led8green = new THREE.BoxGeometry(504, 20, 20);
		const led8greenmesh = new THREE.Mesh(led8green, greenDarkmaterial);
		led8greenmesh.position.set( 0, -90 , -200);
		cardsObject.add(led8greenmesh);
		//led9
		const led9green = new THREE.BoxGeometry(504, 20, 20);
		const led9greenmesh = new THREE.Mesh(led9green, greenDarkmaterial);
		led9greenmesh.position.set( 0, -120 , -200);
		cardsObject.add(led9greenmesh);		
		
		//CLONE Cards

		const card2 = cardsObject.clone();
		card2.position.set( 0, 0 , 50);
		plcObject.add(card2);
		
		const card3 = cardsObject.clone();
		card3.position.set( 0, 0 , 100);
		plcObject.add(card3);
		
		const card4 = cardsObject.clone();
		card4.position.set( 0, 0 , 150);
		plcObject.add(card4);	
		
		const card5 = cardsObject.clone();
		card5.position.set( 0, 0 , 200);
		plcObject.add(card5);
		
		// baseScreen
		const baseScreengeometry = new THREE.BoxGeometry(502, 270, 200);
		const baseScreengeometrymesh = new THREE.Mesh(baseScreengeometry, blackmaterial);
		baseScreengeometrymesh.position.set( 0, 0 , 120);
		plcObject.add(baseScreengeometrymesh);	
		
		// 1livel
		const livel1geometry = new THREE.BoxGeometry(550, 150, 150);
		const livel1geometrymesh = new THREE.Mesh(livel1geometry, graymaterial);
		livel1geometrymesh.position.set( 0, 0 , 120);
		plcObject.add(livel1geometrymesh);
		// 2livel
		const livel2geometry = new THREE.BoxGeometry(590, 100, 149);
		const livel2geometrymesh = new THREE.Mesh(livel2geometry, graymaterial2);
		livel2geometrymesh.position.set( 0, 0 , 120);
		plcObject.add(livel2geometrymesh);			

		plcObject.add(cardsObject);
		
		plcObject.scale.setX(0.7);
		plcObject.scale.setY(0.7);
		plcObject.scale.setZ(0.7);		

		return plcObject;
	}	
		//RV
	export function rv(param) {
		const width=800, height=2500, depth=800;
		const rv = new THREE.Object3D();
		const rv_rackObject = new THREE.Object3D();
		const pspump_rackObject = new THREE.Object3D();
	
		const materialGreyDark= new THREE.MeshLambertMaterial({color: 0x9d9d9d});
		const materialGreyMedium= new THREE.MeshLambertMaterial({color: 0x636363});
		const materialVeryGreyDark= new THREE.MeshLambertMaterial({color: 0x242424});
		const silvermaterial = new THREE.MeshLambertMaterial({color: 0xcfcfcf});
		const greenmaterial = new THREE.MeshLambertMaterial({color: 0x17fc03});
		const Darkwhitematerial = new THREE.MeshLambertMaterial({color: 0xbababa});
		const bluematerial = new THREE.MeshLambertMaterial({color: 0x0053d9});
		const softbluematerial = new THREE.MeshLambertMaterial({color: 0x2b7cff});
		const screenmaterial = new THREE.MeshLambertMaterial({color: 0xdeebff});
		const target = new THREE.MeshLambertMaterial({color: 0xfbe928});

		const materialBase = new THREE.MeshLambertMaterial({color: 0x0000d0});
		const text = param.name;
		let group, textMesh, textGeo, materials;
		let size = 60;
		let textheight = 10;
		let pos = [];
		let rot = [];
		const hover = 30;
		const curveSegments = 8;
		let font;
		function insertText(isize, ipos, irot) {
			group = new THREE.Group();
			group.position.y = 100;
			rv.add( group );
			size = isize;
			pos = ipos;
			rot = irot;
			loadFont();
		}
		function loadFont() {
			const loader = new FontLoader();
			// https://threejs.org/examples/fonts/droid_sans_bold.typeface.json
			loader.load( './fonts/droid_sans_bold.typeface.json', function ( response ) {
				font = response;
				refreshText();
			} );
		}
		function createText() {
			textGeo = new TextGeometry(text, {font: font, size: size, height: textheight, curveSegments: curveSegments});
			textGeo.computeBoundingBox();
			const centerOffset = -0.5 * (textGeo.boundingBox.max.x - textGeo.boundingBox.min.x);
			textMesh = new THREE.Mesh(textGeo, materialBase);
			textMesh.position.x = pos[0];
			textMesh.position.y = pos[1];
			textMesh.position.z = pos[2];
			textMesh.rotation.x = rot[0];
			textMesh.rotation.y = rot[1];
			textMesh.rotation.z = rot[2];
			group.add( textMesh );
			const group2 = group.clone();
			group2.rotateY(Math.PI);
			group2.position.set(800, 90, 800);
			rv.add(group2);				
			
		}
		function refreshText() {
			group.remove( textMesh );
			if ( ! text ) return;
			createText();
		}
		insertText(50, [850, 1290, 550], [0, Math.PI / 2, 0]);
	
		
		
		// rack
		const rrgeometry = new THREE.BoxGeometry(width, height, depth);
		const rrmesh = new THREE.Mesh(rrgeometry, softbluematerial);
		//rrmesh.position.set( 0, 0 , -810);
		rv_rackObject.add(rrmesh);
		
		//front yellow tag
		const Ftarget = new THREE.BoxGeometry(2, 90, 600);
		const Ftargetmesh = new THREE.Mesh(Ftarget, target);
		Ftargetmesh.position.set( -451, 1200 , -5);
		rv_rackObject.add(Ftargetmesh);		
		//Rear yellow tag
		const Rtarget = new THREE.BoxGeometry(2, 90, 600);
		const Rtargetmesh = new THREE.Mesh(Rtarget, target);
		Rtargetmesh.position.set( 401, 1200 , -5);
		rv_rackObject.add(Rtargetmesh);				
		
		//edge lle	
		const llegeometry = new THREE.BoxGeometry(width-750, height, depth-750);
		const llemesh = new THREE.Mesh(llegeometry, bluematerial);
		llemesh.position.set( -425, 0 , -365);
		rv_rackObject.add(llemesh);
		
		//edge lre		
		const lregeometry = new THREE.BoxGeometry(width-750, height, depth-750);
		const lremesh = new THREE.Mesh(lregeometry, bluematerial);
		lremesh.position.set( -425, 0 , 380);
		rv_rackObject.add(lremesh);		

		//edge lue		
		const luegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const luemesh = new THREE.Mesh(luegeometry, bluematerial);
		luemesh.position.set( -425, 1225 , 3);
		rv_rackObject.add(luemesh);		

		//edge lde		
		const ldegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const ldemesh = new THREE.Mesh(ldegeometry, bluematerial);
		ldemesh.position.set( -425, -1230 , 3);
		rv_rackObject.add(ldemesh);				
		//silverbase		
		const drawer1geometry = new THREE.BoxGeometry(10, 2450, 750);
		const drawer1geometrymesh = new THREE.Mesh(drawer1geometry, silvermaterial);
		drawer1geometrymesh.position.set( -400, 0 , -10);
		rv_rackObject.add(drawer1geometrymesh);
		
		//base PS ionic Pump
		const baseionicpump = new THREE.BoxGeometry(10, 250, 300);
		const baseionicpumpmesh = new THREE.Mesh(baseionicpump, Darkwhitematerial);
		baseionicpumpmesh.position.set( -401, 900 , -150);
		pspump_rackObject.add(baseionicpumpmesh);		

		//sceen PS ionic Pump
		const screenionicpump = new THREE.BoxGeometry(10, 60, 180);
		const screenionicpumpmesh = new THREE.Mesh(screenionicpump, screenmaterial);
		screenionicpumpmesh.position.set( -402, 950 , -150);
		pspump_rackObject.add(screenionicpumpmesh);			
		
		//button ON OFF PS ionic Pump
		const buttonionicpump = new THREE.BoxGeometry(10, 50, 30);
		const buttonionicpumpmesh = new THREE.Mesh(buttonionicpump, materialVeryGreyDark);
		buttonionicpumpmesh.position.set( -402, 830 , -250);
		pspump_rackObject.add(buttonionicpumpmesh);	
		
		//button ON Details 
		const I = new THREE.BoxGeometry(3, 12, 3);
		const IMesh = new THREE.Mesh(I, Darkwhitematerial);
		IMesh.position.set( -407, 844 , -250);
		pspump_rackObject.add(IMesh);	
		
		//button OFF Details 
		const OI1 = new THREE.CylinderGeometry(8, 8, 2, 15);
		const OI1Mesh = new THREE.Mesh(OI1, Darkwhitematerial);
		OI1Mesh.rotateX(Math.PI * 0.5);
		OI1Mesh.rotateY(Math.PI * 1);
		OI1Mesh.rotateZ(Math.PI * 0.5);
		OI1Mesh.position.set( -407, 817 , -250);		
		pspump_rackObject.add(OI1Mesh);		

		//button OFF Details 2
		const OI2 = new THREE.CylinderGeometry(6, 6, 2, 15);
		const OI2Mesh = new THREE.Mesh(OI2, materialVeryGreyDark);
		OI2Mesh.rotateX(Math.PI * 0.5);
		OI2Mesh.rotateY(Math.PI * 1);
		OI2Mesh.rotateZ(Math.PI * 0.5);
		OI2Mesh.position.set( -408, 817 , -250);		
		pspump_rackObject.add(OI2Mesh);	
		
		//border up
		const borderup = new THREE.BoxGeometry(10, 2, 260);
		const borderupmesh = new THREE.Mesh(borderup, bluematerial);
		borderupmesh.position.set( -402, 1000 , -150);
		pspump_rackObject.add(borderupmesh);	
		
		//border mid
		const bordermid = new THREE.BoxGeometry(10, 2, 260);
		const bordermidmesh = new THREE.Mesh(bordermid, bluematerial);
		bordermidmesh.position.set( -402, 900 , -150);
		pspump_rackObject.add(bordermidmesh);
		
		//border left
		const borderleft = new THREE.BoxGeometry(10, 100, 2);
		const borderleftmesh = new THREE.Mesh(borderleft, bluematerial);
		borderleftmesh.position.set( -402, 950 , -280);
		pspump_rackObject.add(borderleftmesh);	
		
		//border right
		const borderright = new THREE.BoxGeometry(10, 100, 2);
		const borderrightmesh = new THREE.Mesh(borderright, bluematerial);
		borderrightmesh.position.set( -402, 950 , -20);
		pspump_rackObject.add(borderrightmesh);		
		
		//button1  PS ionic Pump
		const button1ionicpump = new THREE.BoxGeometry(10, 30, 30);
		const button1ionicpumpmesh = new THREE.Mesh(button1ionicpump, materialGreyDark);
		button1ionicpumpmesh.position.set( -402, 830 , -200);
		pspump_rackObject.add(button1ionicpumpmesh);			
		
		//button2 up  PS ionic Pump
		const button2ionicpump = new THREE.BoxGeometry(10, 30, 30);
		const button2ionicpumpmesh = new THREE.Mesh(button2ionicpump, materialGreyDark);
		button2ionicpumpmesh.position.set( -402, 860 , -160);
		pspump_rackObject.add(button2ionicpumpmesh);
		
		//button3 up  PS ionic Pump
		const button3ionicpump = new THREE.BoxGeometry(10, 30, 30);
		const button3ionicpumpmesh = new THREE.Mesh(button3ionicpump, materialGreyDark);
		button3ionicpumpmesh.position.set( -402, 860 , -120);
		pspump_rackObject.add(button3ionicpumpmesh);
		
		//button4 up  PS ionic Pump
		const button4ionicpump = new THREE.BoxGeometry(10, 30, 30);
		const button4ionicpumpmesh = new THREE.Mesh(button4ionicpump, materialGreyDark);
		button4ionicpumpmesh.position.set( -402, 860 , -80);
		pspump_rackObject.add(button4ionicpumpmesh);
		
		//button5 up  PS ionic Pump
		const button5ionicpump = new THREE.BoxGeometry(10, 30, 30);
		const button5ionicpumpmesh = new THREE.Mesh(button5ionicpump, materialGreyDark);
		button5ionicpumpmesh.position.set( -402, 860 , -40);
		pspump_rackObject.add(button5ionicpumpmesh);	

		rv_rackObject.add(pspump_rackObject);
		//CLONE PS PUMP

		const pump2 = pspump_rackObject.clone();
		pump2.position.set( 0, 0 , 310);
		rv_rackObject.add(pump2);
		
		const pump3 = pspump_rackObject.clone();
		pump3.position.set( 0, -260 , 0);
		rv_rackObject.add(pump3);	
		
		const pump4 = pspump_rackObject.clone();
		pump4.position.set( 0, -260 , 310);
		rv_rackObject.add(pump4);
		
		const pump5 = pspump_rackObject.clone();
		pump5.position.set( 0, -520 , 0);
		rv_rackObject.add(pump5);
		
		const pump6 = pspump_rackObject.clone();
		pump6.position.set( 0, -520 , 310);
		rv_rackObject.add(pump6);

		if (typeof param.reverse != 'undefined') rv_rackObject.rotateY(Math.PI);
		rv_rackObject.position.set(400, 200, 400);
		rv.add(rv_rackObject);
		return rv;
	}

	// rrf rack
	export function rrf(param) {
		const width=800, height=2500, depth=600;
		const rrf = new THREE.Object3D();
		const rrf_rackObject = new THREE.Object3D();
	
		const bluematerial = new THREE.MeshLambertMaterial({color: 0x0053d9});
		const softbluematerial = new THREE.MeshLambertMaterial({color: 0x2b7cff});
		const target = new THREE.MeshLambertMaterial({color: 0xfbe928});
		const materialGreyDark= new THREE.MeshLambertMaterial({color: 0x9d9d9d});
		const materialGreyMedium= new THREE.MeshLambertMaterial({color: 0x636363});
		const silvermaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		const materialVeryGreyDark= new THREE.MeshLambertMaterial({color: 0x242424});		

		const materialBase = new THREE.MeshLambertMaterial({color: 0x0000d0});
		const text = param.name;
		let group, textMesh, textGeo, materials;
		let size = 60;
		let textheight = 10;
		let pos = [];
		let rot = [];
		const hover = 30;
		const curveSegments = 8;
		let font;
		function insertText(isize, ipos, irot) {
			group = new THREE.Group();
			group.position.y = 100;
			rrf.add( group );
			size = isize;
			pos = ipos;
			rot = irot;
			loadFont();
		}
		function loadFont() {
			const loader = new FontLoader();
			// https://threejs.org/examples/fonts/droid_sans_bold.typeface.json
			loader.load( './fonts/droid_sans_bold.typeface.json', function ( response ) {
				font = response;
				refreshText();
			} );
		}
		function createText() {
			textGeo = new TextGeometry(text, {font: font, size: size, height: textheight, curveSegments: curveSegments});
			textGeo.computeBoundingBox();
			const centerOffset = -0.5 * (textGeo.boundingBox.max.x - textGeo.boundingBox.min.x);
			textMesh = new THREE.Mesh(textGeo, materialBase);
			textMesh.position.x = pos[0];
			textMesh.position.y = pos[1];
			textMesh.position.z = pos[2];
			textMesh.rotation.x = rot[0];
			textMesh.rotation.y = rot[1];
			textMesh.rotation.z = rot[2];
			group.add( textMesh );
			const group2 = group.clone();
			group2.rotateY(Math.PI);
			group2.position.set(800, 90, 800);
			rrf.add(group2);				
			
		}
		function refreshText() {
			group.remove( textMesh );
			if ( ! text ) return;
			createText();
		}
		insertText(50, [850, 1290, 550], [0, Math.PI / 2, 0]);		
		
		
		//rack
		const rrgeometry = new THREE.BoxGeometry(width, height, depth);
		const rrmesh = new THREE.Mesh(rrgeometry, silvermaterial);
		rrmesh.position.set( 0, 0 , -10);
		rrf_rackObject.add(rrmesh);		
		
		//front yellow target
		const Ftarget = new THREE.BoxGeometry(2, 90, 500);
		const Ftargetmesh = new THREE.Mesh(Ftarget, target);
		Ftargetmesh.position.set( -451, 1200 , -15);
		rrf_rackObject.add(Ftargetmesh);		
		//Rear yellow target
		const Rtarget = new THREE.BoxGeometry(2, 90, 500);
		const Rtargetmesh = new THREE.Mesh(Rtarget, target);
		Rtargetmesh.position.set( 401, 1200 , -15);
		rrf_rackObject.add(Rtargetmesh);				
		
		//edge le	
		const llegeometry = new THREE.BoxGeometry(width-750, height, depth-550);
		const llemesh = new THREE.Mesh(llegeometry, materialGreyDark);
		llemesh.position.set( -425, 0 , -285);
		rrf_rackObject.add(llemesh);
		
		//edge re		
		const lregeometry = new THREE.BoxGeometry(width-750, height, depth-550);
		const lremesh = new THREE.Mesh(lregeometry, materialGreyDark);
		lremesh.position.set( -425, 0 , 265);
		rrf_rackObject.add(lremesh);		

		//edge ue		
		const luegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const luemesh = new THREE.Mesh(luegeometry, materialGreyDark);
		luemesh.position.set( -425, 1225 , -7);
		rrf_rackObject.add(luemesh);		

		//edge de		
		const ldegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const ldemesh = new THREE.Mesh(ldegeometry, materialGreyDark);
		ldemesh.position.set( -425, -1230 , -7);
		rrf_rackObject.add(ldemesh);				

		
		//drawer 1
		const libera1geometry = new THREE.BoxGeometry(10, 200, 600);
		const libera1geometrymesh = new THREE.Mesh(libera1geometry, materialGreyMedium);
		libera1geometrymesh.position.set( -400, 900 , -10);
		rrf_rackObject.add(libera1geometrymesh);		
		
		//drawer 2
		const libera2geometrymesh = new THREE.Mesh(libera1geometry, materialGreyMedium);
		libera2geometrymesh.position.set( -400, 600 , -10);
		rrf_rackObject.add(libera2geometrymesh);				
		
		//drawer 3
		const libera3geometrymesh = new THREE.Mesh(libera1geometry, materialGreyMedium);
		libera3geometrymesh.position.set( -400, 300 , -10);
		rrf_rackObject.add(libera3geometrymesh);			
		
		//drawer 4
		const libera4geometrymesh = new THREE.Mesh(libera1geometry, materialGreyMedium);
		libera4geometrymesh.position.set( -400, 0 , -10);
		rrf_rackObject.add(libera4geometrymesh);			
		
		//drawer 5
		const libera5geometrymesh = new THREE.Mesh(libera1geometry, materialGreyMedium);
		libera5geometrymesh.position.set( -400, -300 , -10);
		rrf_rackObject.add(libera5geometrymesh);			
		
		//drawer 6
		const libera6geometrymesh = new THREE.Mesh(libera1geometry, materialGreyMedium);
		libera6geometrymesh.position.set( -400, -600 , -10);
		rrf_rackObject.add(libera6geometrymesh);	
		
		if (typeof param.reverse != 'undefined') rrf_rackObject.rotateY(Math.PI);
		rrf_rackObject.position.set(400, 200, 400);
		rrf.add(rrf_rackObject);
		return rrf;
	}


	// PS rack
	export function rps(param) {
		const width=800, height=2500, depth=600;
		const psObject = new THREE.Object3D();
		const rps_rackObject = new THREE.Object3D();
		const rps = new THREE.Object3D();

		const materialBase = new THREE.MeshLambertMaterial({color: 0x0000b0});
		const text = param.name;
		let group, textMesh, textGeo, materials;
		let size = 60;
		let textheight = 10;
		let pos = [];
		let rot = [];
		const hover = 30;
		const curveSegments = 8;
		let font;
		function insertText(isize, ipos, irot) {
			group = new THREE.Group();
			group.position.y = 100;
			rps.add( group );
			size = isize;
			pos = ipos;
			rot = irot;
			loadFont();
		}
		function loadFont() {
			const loader = new FontLoader();
			// https://threejs.org/examples/fonts/droid_sans_bold.typeface.json
			loader.load( './fonts/droid_sans_bold.typeface.json', function ( response ) {
				font = response;
				refreshText();
			} );
		}
		function createText() {
			textGeo = new TextGeometry(text, {font: font, size: size, height: textheight, curveSegments: curveSegments});
			textGeo.computeBoundingBox();
			const centerOffset = -0.5 * (textGeo.boundingBox.max.x - textGeo.boundingBox.min.x);
			textMesh = new THREE.Mesh(textGeo, materialBase);
			textMesh.position.x = pos[0];
			textMesh.position.y = pos[1];
			textMesh.position.z = pos[2];
			textMesh.rotation.x = rot[0];
			textMesh.rotation.y = rot[1];
			textMesh.rotation.z = rot[2];
			group.add( textMesh );
			const group2 = group.clone();
			group2.rotateY(Math.PI);
			group2.position.set(800, 90, 550);
			rps.add(group2);			
			
		}
		function refreshText() {
			group.remove( textMesh );
			if ( ! text ) return;
			createText();
		}
		insertText(50, [870, 1290, 550], [0, Math.PI / 2, 0]);
	
		const materialGreyDark= new THREE.MeshLambertMaterial({color: 0x9d9d9d});
		const materialGreyMedium= new THREE.MeshLambertMaterial({color: 0x636363});
		const materialVeryGreyDark= new THREE.MeshLambertMaterial({color: 0x242424});
		const Darkwhitematerial = new THREE.MeshLambertMaterial({color: 0xbababa});
		const silvermaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		const greenmaterial = new THREE.MeshLambertMaterial({color: 0x17fc03});
		const whitematerial = new THREE.MeshLambertMaterial({color: 0xffffff});
		const bluematerial = new THREE.MeshLambertMaterial({color: 0x0053d9});
		const softbluematerial = new THREE.MeshLambertMaterial({color: 0x2b7cff});
		const screenmaterial = new THREE.MeshLambertMaterial({color: 0xdeebff});
		const target = new THREE.MeshLambertMaterial({color: 0xfbe928});
		
		// rack
		const rrgeometry = new THREE.BoxGeometry(width, height, depth);
		const rrmesh = new THREE.Mesh(rrgeometry, softbluematerial);
		rrmesh.position.set( 0, 0 , 0);
		rps_rackObject.add(rrmesh);		
		
		//edge le	
		const llegeometry = new THREE.BoxGeometry(width-750, height, depth-550);
		const llemesh = new THREE.Mesh(llegeometry, bluematerial);
		llemesh.position.set( -425, 0 , -285);
		rps_rackObject.add(llemesh);
		
		//edge re		
		const lregeometry = new THREE.BoxGeometry(width-750, height, depth-550);
		const lremesh = new THREE.Mesh(lregeometry, bluematerial);
		lremesh.position.set( -425, 0 , 265);
		rps_rackObject.add(lremesh);		

		//edge ue		
		const luegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const luemesh = new THREE.Mesh(luegeometry, bluematerial);
		luemesh.position.set( -425, 1225 , -7);
		rps_rackObject.add(luemesh);		

		//edge de		
		const ldegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const ldemesh = new THREE.Mesh(ldegeometry, bluematerial);
		ldemesh.position.set( -425, -1230 , -7);
		rps_rackObject.add(ldemesh);				

		//front yellow target
		const Ftarget = new THREE.BoxGeometry(2, 90, 600);
		const Ftargetmesh = new THREE.Mesh(Ftarget, target);
		Ftargetmesh.position.set( -451, 1200 , -15);
		rps_rackObject.add(Ftargetmesh);		
		//Rear yellow target
		const Rtarget = new THREE.BoxGeometry(2, 90, 600);
		const Rtargetmesh = new THREE.Mesh(Rtarget, target);
		Rtargetmesh.position.set( 401, 1200 , -15);
		rps_rackObject.add(Rtargetmesh);				
	
		// START PS base RED 
		const basered = new THREE.BoxGeometry(10, 30, 110);
		const baseredmesh = new THREE.Mesh(basered, silvermaterial);
		baseredmesh.position.set( -401, 1100 , -170);
		psObject.add(baseredmesh);
		
		//  PS base BLUE 
		const baseblue = new THREE.BoxGeometry(10, 180, 110);
		const basebluemesh = new THREE.Mesh(baseblue, Darkwhitematerial);
		basebluemesh.position.set( -401, 995 , -170);
		psObject.add(basebluemesh);			

		//  PS base SILVER 
		const basesilver = new THREE.BoxGeometry(10, 2450, 500);
		const basesilvermesh = new THREE.Mesh(basesilver, materialGreyDark);
		basesilvermesh.position.set( -400, 0 , 0);
		rps_rackObject.add(basesilvermesh);			
		
		rps_rackObject.add(psObject);
		
		//CLONE PS 

		const psA3 = psObject.clone();
		psA3.position.set( 0, 0 , 240);
		rps_rackObject.add(psA3);	
		
		const psB1 = psObject.clone();
		psB1.position.set( 0, -220 , 0);
		rps_rackObject.add(psB1);
		
     	const psB3 = psObject.clone();
		psB3.position.set( 0, -220 , 240);
		rps_rackObject.add(psB3);
		
		const psC1 = psObject.clone();
		psC1.position.set( 0, -440 , 0);
		rps_rackObject.add(psC1);

		const psC3 = psObject.clone();
		psC3.position.set( 0, -440 , 240);
		rps_rackObject.add(psC3);
		
		const psD1 = psObject.clone();
		psD1.position.set( 0, -660 , 0);
		rps_rackObject.add(psD1);
	
		const psD3 = psObject.clone();
		psD3.position.set( 0, -660 , 240);
		rps_rackObject.add(psD3);	
		
		const psE1 = psObject.clone();
		psE1.position.set( 0, -880 , 0);
		rps_rackObject.add(psE1);
		
		
		const psE3 = psObject.clone();
		psE3.position.set( 0, -880 , 240);
		rps_rackObject.add(psE3);		
		
		if (typeof param.reverse != 'undefined') rps_rackObject.rotateY(Math.PI);
		rps_rackObject.position.set(400, 200, 300);
		rps.add(rps_rackObject);	
		return rps;
	}

	// Control rack
	export function rc(param) {
		const width=800, height=2500, depth=600;
		const rc = new THREE.Object3D();
		const rc_rackObject = new THREE.Object3D();
		const materialBase = new THREE.MeshLambertMaterial({color: 0x0000d0});
		const text = param.name;
		let group, textMesh, textGeo, materials;
		let size = 60;
		let textheight = 10;
		let pos = [];
		let rot = [];
		const hover = 30;
		const curveSegments = 8;
		let font;
		function insertText(isize, ipos, irot) {
			group = new THREE.Group();
			group.position.y = 100;
			rc.add( group );
			size = isize;
			pos = ipos;
			rot = irot;
			loadFont();
		}
		function loadFont() {
			const loader = new FontLoader();
			// https://threejs.org/examples/fonts/droid_sans_bold.typeface.json
			loader.load( './fonts/droid_sans_bold.typeface.json', function ( response ) {
				font = response;
				refreshText();
			} );
		}
		function createText() {
			textGeo = new TextGeometry(text, {font: font, size: size, height: textheight, curveSegments: curveSegments});
			textGeo.computeBoundingBox();
			const centerOffset = -0.5 * (textGeo.boundingBox.max.x - textGeo.boundingBox.min.x);
			textMesh = new THREE.Mesh(textGeo, materialBase);
			textMesh.position.x = pos[0];
			textMesh.position.y = pos[1];
			textMesh.position.z = pos[2];
			textMesh.rotation.x = rot[0];
			textMesh.rotation.y = rot[1];
			textMesh.rotation.z = rot[2];
			group.add( textMesh );
			const group2 = group.clone();
			group2.rotateY(Math.PI);
			group2.position.set(850, 90, 550);
			rc.add(group2);			
			
		}
		function refreshText() {
			group.remove( textMesh );
			if ( ! text ) return;
			createText();
		}
		insertText(50, [900, 1290, 500], [0, Math.PI / 2, 0]);
	
		const bluematerial = new THREE.MeshLambertMaterial({color: 0x0053d9});
		const softbluematerial = new THREE.MeshLambertMaterial({color: 0x2b7cff});
		const target = new THREE.MeshLambertMaterial({color: 0xfbe928});
		const materialGreyDark= new THREE.MeshLambertMaterial({color: 0x9d9d9d});
		const materialGreyMedium= new THREE.MeshLambertMaterial({color: 0x636363});
		
		//rack
		const rrgeometry = new THREE.BoxGeometry(width, height, depth);
		const rrmesh = new THREE.Mesh(rrgeometry, softbluematerial);
		rrmesh.position.set( 0, 0 , -10);
		rc_rackObject.add(rrmesh);		
		
		//front yellow target
		const Ftarget = new THREE.BoxGeometry(2, 90, 500);
		const Ftargetmesh = new THREE.Mesh(Ftarget, target);
		Ftargetmesh.position.set( -451, 1200 , -15);
		rc_rackObject.add(Ftargetmesh);		
		//Rear yellow target
		const Rtarget = new THREE.BoxGeometry(2, 90, 500);
		const Rtargetmesh = new THREE.Mesh(Rtarget, target);
		Rtargetmesh.position.set( 401, 1200 , -15);
		rc_rackObject.add(Rtargetmesh);				
		
		//edge le	
		const llegeometry = new THREE.BoxGeometry(width-750, height, depth-550);
		const llemesh = new THREE.Mesh(llegeometry, bluematerial);
		llemesh.position.set( -425, 0 , -285);
		rc_rackObject.add(llemesh);
		
		//edge re		
		const lregeometry = new THREE.BoxGeometry(width-750, height, depth-550);
		const lremesh = new THREE.Mesh(lregeometry, bluematerial);
		lremesh.position.set( -425, 0 , 265);
		rc_rackObject.add(lremesh);		

		//edge ue		
		const luegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const luemesh = new THREE.Mesh(luegeometry, bluematerial);
		luemesh.position.set( -425, 1225 , -7);
		rc_rackObject.add(luemesh);		

		//edge de		
		const ldegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const ldemesh = new THREE.Mesh(ldegeometry, bluematerial);
		ldemesh.position.set( -425, -1230 , -7);
		rc_rackObject.add(ldemesh);				

	
		//borderEC down
		const borderECgeometry = new THREE.BoxGeometry(10, 400, 600);
		const borderECgeometrymesh = new THREE.Mesh(borderECgeometry, materialGreyDark);
		borderECgeometrymesh.position.set( -400, -250 , -10);
		rc_rackObject.add(borderECgeometrymesh);
		
		//EC1 down
		const EC1geometry = new THREE.BoxGeometry(10, 350, 40);
		const EC1geometrymesh = new THREE.Mesh(EC1geometry, materialGreyMedium);
		EC1geometrymesh.position.set( -402, -250 , -200);
		rc_rackObject.add(EC1geometrymesh);			
		//EC2 down
		const EC2geometry = new THREE.BoxGeometry(10, 350, 40);
		const EC2geometrymesh = new THREE.Mesh(EC2geometry, materialGreyMedium);
		EC2geometrymesh.position.set( -402, -250 , -150);
		rc_rackObject.add(EC2geometrymesh);			
		//EC2 down
		const EC3geometry = new THREE.BoxGeometry(10, 350, 40);
		const EC3geometrymesh = new THREE.Mesh(EC3geometry, materialGreyMedium);
		EC3geometrymesh.position.set( -402, -250 , -100);
		rc_rackObject.add(EC3geometrymesh);		
		
		//borderEC up
		const borderupECgeometry = new THREE.BoxGeometry(10, 400, 600);
		const borderupECgeometrymesh = new THREE.Mesh(borderupECgeometry, materialGreyDark);
		borderupECgeometrymesh.position.set( -400, 250 , -10);
		rc_rackObject.add(borderupECgeometrymesh);
		
		//EC1 up
		const EC1geometryup = new THREE.BoxGeometry(10, 350, 40);
		const EC1geometryupmesh = new THREE.Mesh(EC1geometryup, materialGreyMedium);
		EC1geometryupmesh.position.set( -402, 250 , -200);
		rc_rackObject.add(EC1geometryupmesh);			
		//EC2 up
		const EC2geometryup = new THREE.BoxGeometry(10, 350, 40);
		const EC2geometryupmesh = new THREE.Mesh(EC2geometryup, materialGreyMedium);
		EC2geometryupmesh.position.set( -402, 250 , -150);
		rc_rackObject.add(EC2geometryupmesh);			
		//EC2 up
		const EC3geometryup = new THREE.BoxGeometry(10, 350, 40);
		const EC3geometryupmesh = new THREE.Mesh(EC3geometryup, materialGreyMedium);
		EC3geometryupmesh.position.set( -402, 250 , -100);
		rc_rackObject.add(EC3geometryupmesh);				
		
		if (typeof param.reverse != 'undefined') rc_rackObject.rotateY(Math.PI);
		rc_rackObject.position.set(400, 200, 300);
		rc.add(rc_rackObject);	
		return rc;
	}

	// diagnostic rack
	export function rd(param) {
		const width=800, height=2500, depth=600;
		const rd = new THREE.Object3D();
		const rd_rackObject = new THREE.Object3D();

		const materialBase = new THREE.MeshLambertMaterial({color: 0x0000d0});
		const text = param.name;
		let group, textMesh, textGeo, materials;
		let size = 60;
		let textheight = 10;
		let pos = [];
		let rot = [];
		const hover = 30;
		const curveSegments = 8;
		let font;
		function insertText(isize, ipos, irot) {
			group = new THREE.Group();
			group.position.y = 100;
			rd.add( group );
			size = isize;
			pos = ipos;
			rot = irot;
			loadFont();
		}
		function loadFont() {
			const loader = new FontLoader();
			// https://threejs.org/examples/fonts/droid_sans_bold.typeface.json
			loader.load( './fonts/droid_sans_bold.typeface.json', function ( response ) {
				font = response;
				refreshText();
			} );
		}
		function createText() {
			textGeo = new TextGeometry(text, {font: font, size: size, height: textheight, curveSegments: curveSegments});
			textGeo.computeBoundingBox();
			const centerOffset = -0.5 * (textGeo.boundingBox.max.x - textGeo.boundingBox.min.x);
			textMesh = new THREE.Mesh(textGeo, materialBase);
			textMesh.position.x = pos[0];
			textMesh.position.y = pos[1];
			textMesh.position.z = pos[2];
			textMesh.rotation.x = rot[0];
			textMesh.rotation.y = rot[1];
			textMesh.rotation.z = rot[2];
			group.add( textMesh );
			const group2 = group.clone();
			group2.rotateY(Math.PI);
			group2.position.set(850, 90, 550);
			rd.add(group2);			
			
		}
		function refreshText() {
			group.remove( textMesh );
			if ( ! text ) return;
			createText();
		}
		insertText(50, [900, 1290, 500], [0, Math.PI / 2, 0]);
		
		const bluematerial = new THREE.MeshLambertMaterial({color: 0x0053d9});
		const softbluematerial = new THREE.MeshLambertMaterial({color: 0x2b7cff});
		const target = new THREE.MeshLambertMaterial({color: 0xfbe928});
		const materialGreyDark= new THREE.MeshLambertMaterial({color: 0x9d9d9d});
		const materialGreyMedium= new THREE.MeshLambertMaterial({color: 0x636363});
		
		//rack
		const rrgeometry = new THREE.BoxGeometry(width, height, depth);
		const rrmesh = new THREE.Mesh(rrgeometry, softbluematerial);
		rrmesh.position.set( 0, 0 , -10);
		rd_rackObject.add(rrmesh);		
		
		//front yellow target
		const Ftarget = new THREE.BoxGeometry(2, 90, 500);
		const Ftargetmesh = new THREE.Mesh(Ftarget, target);
		Ftargetmesh.position.set( -451, 1200 , -15);
		rd_rackObject.add(Ftargetmesh);		
		//Rear yellow target
		const Rtarget = new THREE.BoxGeometry(2, 90, 500);
		const Rtargetmesh = new THREE.Mesh(Rtarget, target);
		Rtargetmesh.position.set( 401, 1200 , -15);
		rd_rackObject.add(Rtargetmesh);				
		
		//edge le	
		const llegeometry = new THREE.BoxGeometry(width-750, height, depth-550);
		const llemesh = new THREE.Mesh(llegeometry, bluematerial);
		llemesh.position.set( -425, 0 , -285);
		rd_rackObject.add(llemesh);
		
		//edge re		
		const lregeometry = new THREE.BoxGeometry(width-750, height, depth-550);
		const lremesh = new THREE.Mesh(lregeometry, bluematerial);
		lremesh.position.set( -425, 0 , 265);
		rd_rackObject.add(lremesh);		

		//edge ue		
		const luegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const luemesh = new THREE.Mesh(luegeometry, bluematerial);
		luemesh.position.set( -425, 1225 , -7);
		rd_rackObject.add(luemesh);		

		//edge de		
		const ldegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const ldemesh = new THREE.Mesh(ldegeometry, bluematerial);
		ldemesh.position.set( -425, -1230 , -7);
		rd_rackObject.add(ldemesh);				

	
		//borderEC 
		const borderECgeometry = new THREE.BoxGeometry(10, 400, 600);
		const borderECgeometrymesh = new THREE.Mesh(borderECgeometry, materialGreyDark);
		borderECgeometrymesh.position.set( -400, 0 , -10);
		rd_rackObject.add(borderECgeometrymesh);
		
		//EC1 
		const EC1geometry = new THREE.BoxGeometry(10, 350, 40);
		const EC1geometrymesh = new THREE.Mesh(EC1geometry, materialGreyMedium);
		EC1geometrymesh.position.set( -402, 0 , -200);
		rd_rackObject.add(EC1geometrymesh);			
		//EC2 
		const EC2geometry = new THREE.BoxGeometry(10, 350, 40);
		const EC2geometrymesh = new THREE.Mesh(EC2geometry, materialGreyMedium);
		EC2geometrymesh.position.set( -402, 0 , -150);
		rd_rackObject.add(EC2geometrymesh);			
		//EC2 
		const EC3geometry = new THREE.BoxGeometry(10, 350, 40);
		const EC3geometrymesh = new THREE.Mesh(EC3geometry, materialGreyMedium);
		EC3geometrymesh.position.set( -402, 0 , -100);
		rd_rackObject.add(EC3geometrymesh);		
		
		//libera 1
		const libera1geometry = new THREE.BoxGeometry(10, 100, 600);
		const libera1geometrymesh = new THREE.Mesh(libera1geometry, materialGreyMedium);
		libera1geometrymesh.position.set( -400, 900 , -10);
		rd_rackObject.add(libera1geometrymesh);		
		
		//libera 2
		const libera2geometrymesh = new THREE.Mesh(libera1geometry, materialGreyMedium);
		libera2geometrymesh.position.set( -400, 750 , -10);
		rd_rackObject.add(libera2geometrymesh);				
		
		//libera 3
		const libera3geometrymesh = new THREE.Mesh(libera1geometry, materialGreyMedium);
		libera3geometrymesh.position.set( -400, 600 , -10);
		rd_rackObject.add(libera3geometrymesh);			
		
		//libera 4
		const libera4geometrymesh = new THREE.Mesh(libera1geometry, materialGreyMedium);
		libera4geometrymesh.position.set( -400, -600 , -10);
		rd_rackObject.add(libera4geometrymesh);			
		
		//libera 5
		const libera5geometrymesh = new THREE.Mesh(libera1geometry, materialGreyMedium);
		libera5geometrymesh.position.set( -400, -750 , -10);
		rd_rackObject.add(libera5geometrymesh);			
		
		//libera 6
		const libera6geometrymesh = new THREE.Mesh(libera1geometry, materialGreyMedium);
		libera6geometrymesh.position.set( -400, -900 , -10);
		rd_rackObject.add(libera6geometrymesh);	

		if (typeof param.reverse != 'undefined') rd_rackObject.rotateY(Math.PI);
		rd_rackObject.position.set(400, 200, 300);
		rd.add(rd_rackObject);	
		return rd;
	}		
	// NULL rack
	export function zero(param) {
		const width=800, height=2500, depth=600;
		const zero = new THREE.Object3D();
		const zero_rackObject = new THREE.Object3D();

		const materialBase = new THREE.MeshLambertMaterial({color: 0x0000d0});
		const text = param.name;
		let group, textMesh, textGeo, materials;
		let size = 60;
		let textheight = 10;
		let pos = [];
		let rot = [];
		const hover = 30;
		const curveSegments = 8;
		let font;
		function insertText(isize, ipos, irot) {
			group = new THREE.Group();
			group.position.y = 100;
			zero.add( group );
			size = isize;
			pos = ipos;
			rot = irot;
			loadFont();
		}
		function loadFont() {
			const loader = new FontLoader();
			// https://threejs.org/examples/fonts/droid_sans_bold.typeface.json
			loader.load( './fonts/droid_sans_bold.typeface.json', function ( response ) {
				font = response;
				refreshText();
			} );
		}
		function createText() {
			textGeo = new TextGeometry(text, {font: font, size: size, height: textheight, curveSegments: curveSegments});
			textGeo.computeBoundingBox();
			const centerOffset = -0.5 * (textGeo.boundingBox.max.x - textGeo.boundingBox.min.x);
			textMesh = new THREE.Mesh(textGeo, materialBase);
			textMesh.position.x = pos[0];
			textMesh.position.y = pos[1];
			textMesh.position.z = pos[2];
			textMesh.rotation.x = rot[0];
			textMesh.rotation.y = rot[1];
			textMesh.rotation.z = rot[2];
			group.add( textMesh );
			const group2 = group.clone();
			group2.rotateY(Math.PI);
			group2.position.set(850, 90, 550);
			zero.add(group2);			
			
		}
		function refreshText() {
			group.remove( textMesh );
			if ( ! text ) return;
			createText();
		}
		insertText(50, [900, 1290, 500], [0, Math.PI / 2, 0]);
		
		const bluematerial = new THREE.MeshLambertMaterial({color: 0x0053d9});
		const softbluematerial = new THREE.MeshLambertMaterial({color: 0x2b7cff});
		const target = new THREE.MeshLambertMaterial({color: 0xfbe928});
		const materialGreyDark= new THREE.MeshLambertMaterial({color: 0x9d9d9d});
		const materialGreyMedium= new THREE.MeshLambertMaterial({color: 0x636363});
		
		//rack
		const rrgeometry = new THREE.BoxGeometry(width, height, depth);
		const rrmesh = new THREE.Mesh(rrgeometry, softbluematerial);
		rrmesh.position.set( 0, 0 , -10);
		zero_rackObject.add(rrmesh);		
		
		//front yellow target
		const Ftarget = new THREE.BoxGeometry(2, 90, 500);
		const Ftargetmesh = new THREE.Mesh(Ftarget, target);
		Ftargetmesh.position.set( -451, 1200 , -15);
		zero_rackObject.add(Ftargetmesh);		
		//Rear yellow target
		const Rtarget = new THREE.BoxGeometry(2, 90, 500);
		const Rtargetmesh = new THREE.Mesh(Rtarget, target);
		Rtargetmesh.position.set( 401, 1200 , -15);
		zero_rackObject.add(Rtargetmesh);				
		
		//edge le	
		const llegeometry = new THREE.BoxGeometry(width-750, height, depth-550);
		const llemesh = new THREE.Mesh(llegeometry, bluematerial);
		llemesh.position.set( -425, 0 , -285);
		zero_rackObject.add(llemesh);
		
		//edge re		
		const lregeometry = new THREE.BoxGeometry(width-750, height, depth-550);
		const lremesh = new THREE.Mesh(lregeometry, bluematerial);
		lremesh.position.set( -425, 0 , 265);
		zero_rackObject.add(lremesh);		

		//edge ue		
		const luegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const luemesh = new THREE.Mesh(luegeometry, bluematerial);
		luemesh.position.set( -425, 1225 , -7);
		zero_rackObject.add(luemesh);		

		//edge de		
		const ldegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const ldemesh = new THREE.Mesh(ldegeometry, bluematerial);
		ldemesh.position.set( -425, -1230 , -7);
		zero_rackObject.add(ldemesh);				

	

		if (typeof param.reverse != 'undefined') zero_rackObject.rotateY(Math.PI);
		zero_rackObject.position.set(400, 200, 300);
		zero.add(zero_rackObject);	
		return zero;
	}	



	// Rack Bending Booster
	export function rpsb(param) {
		const width=1000, height=2100, depth=1500;
		const rpsb = new THREE.Object3D();
		const rpsb_rackObject = new THREE.Object3D();
		
		const materialBase = new THREE.MeshLambertMaterial({color: 0x0000d0});
		const text = param.name;
		let group, textMesh, textGeo, materials;
		let size = 60;
		let textheight = 10;
		let pos = [];
		let rot = [];
		const hover = 30;
		const curveSegments = 8;
		let font;
		function insertText(isize, ipos, irot) {
			group = new THREE.Group();
			group.position.y = 100;
			rpsb.add( group );
			size = isize;
			pos = ipos;
			rot = irot;
			loadFont();
		}
		function loadFont() {
			const loader = new FontLoader();
			// https://threejs.org/examples/fonts/droid_sans_bold.typeface.json
			loader.load( './fonts/droid_sans_bold.typeface.json', function ( response ) {
				font = response;
				refreshText();
			} );
		}
		function createText() {
			textGeo = new TextGeometry(text, {font: font, size: size, height: textheight, curveSegments: curveSegments});
			textGeo.computeBoundingBox();
			const centerOffset = -0.5 * (textGeo.boundingBox.max.x - textGeo.boundingBox.min.x);
			textMesh = new THREE.Mesh(textGeo, materialBase);
			textMesh.position.x = pos[0];
			textMesh.position.y = pos[1];
			textMesh.position.z = pos[2];
			textMesh.rotation.x = rot[0];
			textMesh.rotation.y = rot[1];
			textMesh.rotation.z = rot[2];
			group.add( textMesh );
			const group2 = group.clone();
			group2.rotateY(Math.PI);
			group2.position.set(790, 90, -850);
			rpsb.add(group2);				
		}
		function refreshText() {
			group.remove( textMesh );
			if ( ! text ) return;
			createText();
		}
		insertText(50, [900, 940, -180], [0, Math.PI / 2, 0]);		

		const greenmaterial = new THREE.MeshLambertMaterial({color: 0x00ac76});
		const target = new THREE.MeshLambertMaterial({color: 0xfbe928});
		const redmaterial = new THREE.MeshLambertMaterial({color: 0xff0000});
		const yellowmaterial = new THREE.MeshLambertMaterial({color: 0xcc9d02});
		const whitematerial = new THREE.MeshLambertMaterial({color: 0xffffff});
		const materialThightblue = new THREE.MeshLambertMaterial({color: 0x96a5fa});
		const materialDarkblue = new THREE.MeshLambertMaterial({color: 0x021061});
		const silvermaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		
		//rack
		const geometry = new THREE.BoxGeometry(width, height, depth);
		const rackmesh = new THREE.Mesh(geometry, greenmaterial);
		rackmesh.position.set( 0, 0 ,0);
		rpsb_rackObject.add(rackmesh);	
		
		//emergencybutton yellow 
		const emergencybuttonyellow = new THREE.CylinderGeometry(70, 70, 5, 15);
		const emergencybuttonyellowmesh = new THREE.Mesh(emergencybuttonyellow, yellowmaterial);
		emergencybuttonyellowmesh.rotateX(Math.PI * 0.5);
		emergencybuttonyellowmesh.rotateY(Math.PI * 1);
		emergencybuttonyellowmesh.rotateZ(Math.PI * 0.5);		
		emergencybuttonyellowmesh.position.set(-503, 520 , 0);		
		rpsb_rackObject.add(emergencybuttonyellowmesh);				
		
		//emergencybutton red  
		const emergencybutton = new THREE.CylinderGeometry(50, 50, 30, 15);
		const emergencybuttonmesh = new THREE.Mesh(emergencybutton, redmaterial);
		emergencybuttonmesh.rotateX(Math.PI * 0.5);
		emergencybuttonmesh.rotateY(Math.PI * 1);
		emergencybuttonmesh.rotateZ(Math.PI * 0.5);		
		emergencybuttonmesh.position.set(-505, 520 , 0);		
		rpsb_rackObject.add(emergencybuttonmesh);	
		
		//base border	
		const screenbordergeometry = new THREE.BoxGeometry(10, 350, 450);
		const screenbordergeometrymesh = new THREE.Mesh(screenbordergeometry, whitematerial);
		screenbordergeometrymesh.position.set( -500, 600 , 0);
		rpsb_rackObject.add(screenbordergeometrymesh);
		
		//screen border	
		const basebordergeometry = new THREE.BoxGeometry(10,  100, 100);
		const basebordergeometrymesh = new THREE.Mesh(basebordergeometry, silvermaterial);
		basebordergeometrymesh.position.set( -501, 700 , 0);
		rpsb_rackObject.add(basebordergeometrymesh);
		
		//screen 	
		const screengeometry = new THREE.BoxGeometry(10, 80, 80);
		const screengeometrymesh = new THREE.Mesh(screengeometry, materialDarkblue);
		screengeometrymesh.position.set( -502, 700 , 0);
		rpsb_rackObject.add(screengeometrymesh);		
		
		//front yellow target
		const Ftarget = new THREE.BoxGeometry(2, 90, 600);
		const Ftargetmesh = new THREE.Mesh(Ftarget, target);
		Ftargetmesh.position.set( -504, 999 , 0);
		rpsb_rackObject.add(Ftargetmesh);		
		//Rear yellow target
		const Rtarget = new THREE.BoxGeometry(2, 90, 600);
		const Rtargetmesh = new THREE.Mesh(Rtarget, target);
		Rtargetmesh.position.set( 504, 999 , 0);
		rpsb_rackObject.add(Rtargetmesh);		
		
		if (typeof param.reverse != 'undefined') rpsb_rackObject.rotateY(Math.PI);
		rpsb_rackObject.position.set(400, 50, -400);
		rpsb.add(rpsb_rackObject);	
		return rpsb;
	}

	// Rack Quadrupoli Booster
	export function rpsq(param) {
		const width=1000, height=2100, depth=1500;
		const rpsb = new THREE.Object3D();
		const rpsb_rackObject = new THREE.Object3D();
		
		const materialBase = new THREE.MeshLambertMaterial({color: 0x0000d0});
		const text = param.name;
		let group, textMesh, textGeo, materials;
		let size = 60;
		let textheight = 10;
		let pos = [];
		let rot = [];
		const hover = 30;
		const curveSegments = 8;
		let font;
		function insertText(isize, ipos, irot) {
			group = new THREE.Group();
			group.position.y = 100;
			rpsb.add( group );
			size = isize;
			pos = ipos;
			rot = irot;
			loadFont();
		}
		function loadFont() {
			const loader = new FontLoader();
			// https://threejs.org/examples/fonts/droid_sans_bold.typeface.json
			loader.load( './fonts/droid_sans_bold.typeface.json', function ( response ) {
				font = response;
				refreshText();
			} );
		}
		function createText() {
			textGeo = new TextGeometry(text, {font: font, size: size, height: textheight, curveSegments: curveSegments});
			textGeo.computeBoundingBox();
			const centerOffset = -0.5 * (textGeo.boundingBox.max.x - textGeo.boundingBox.min.x);
			textMesh = new THREE.Mesh(textGeo, materialBase);
			textMesh.position.x = pos[0];
			textMesh.position.y = pos[1];
			textMesh.position.z = pos[2];
			textMesh.rotation.x = rot[0];
			textMesh.rotation.y = rot[1];
			textMesh.rotation.z = rot[2];
			group.add( textMesh );
			const group2 = group.clone();
			group2.rotateY(Math.PI);
			group2.position.set(790, 90, -850);
			rpsb.add(group2);				
		}
		function refreshText() {
			group.remove( textMesh );
			if ( ! text ) return;
			createText();
		}
		insertText(50, [900, 940, -180], [0, Math.PI / 2, 0]);		

		const greenmaterial = new THREE.MeshLambertMaterial({color: 0x00ac76});
		const target = new THREE.MeshLambertMaterial({color: 0xfbe928});
		const redmaterial = new THREE.MeshLambertMaterial({color: 0xff0000});
		const yellowmaterial = new THREE.MeshLambertMaterial({color: 0xcc9d02});
		const whitematerial = new THREE.MeshLambertMaterial({color: 0xffffff});
		const materialThightblue = new THREE.MeshLambertMaterial({color: 0x96a5fa});
		const materialDarkblue = new THREE.MeshLambertMaterial({color: 0x021061});
		const silvermaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		
		//rack
		const geometry = new THREE.BoxGeometry(width, height, depth);
		const rackmesh = new THREE.Mesh(geometry, redmaterial);
		rackmesh.position.set( 0, 0 ,0);
		rpsb_rackObject.add(rackmesh);	
		
		//emergencybutton yellow 
		const emergencybuttonyellow = new THREE.CylinderGeometry(70, 70, 5, 15);
		const emergencybuttonyellowmesh = new THREE.Mesh(emergencybuttonyellow, yellowmaterial);
		emergencybuttonyellowmesh.rotateX(Math.PI * 0.5);
		emergencybuttonyellowmesh.rotateY(Math.PI * 1);
		emergencybuttonyellowmesh.rotateZ(Math.PI * 0.5);		
		emergencybuttonyellowmesh.position.set(-503, 520 , 0);		
		rpsb_rackObject.add(emergencybuttonyellowmesh);				
		
		//emergencybutton red  
		const emergencybutton = new THREE.CylinderGeometry(50, 50, 30, 15);
		const emergencybuttonmesh = new THREE.Mesh(emergencybutton, redmaterial);
		emergencybuttonmesh.rotateX(Math.PI * 0.5);
		emergencybuttonmesh.rotateY(Math.PI * 1);
		emergencybuttonmesh.rotateZ(Math.PI * 0.5);		
		emergencybuttonmesh.position.set(-505, 520 , 0);		
		rpsb_rackObject.add(emergencybuttonmesh);	
		
		//base border	
		const screenbordergeometry = new THREE.BoxGeometry(10, 350, 450);
		const screenbordergeometrymesh = new THREE.Mesh(screenbordergeometry, whitematerial);
		screenbordergeometrymesh.position.set( -500, 600 , 0);
		rpsb_rackObject.add(screenbordergeometrymesh);
		
		//screen border	
		const basebordergeometry = new THREE.BoxGeometry(10,  100, 100);
		const basebordergeometrymesh = new THREE.Mesh(basebordergeometry, silvermaterial);
		basebordergeometrymesh.position.set( -501, 700 , 0);
		rpsb_rackObject.add(basebordergeometrymesh);
		
		//screen 	
		const screengeometry = new THREE.BoxGeometry(10, 80, 80);
		const screengeometrymesh = new THREE.Mesh(screengeometry, materialDarkblue);
		screengeometrymesh.position.set( -502, 700 , 0);
		rpsb_rackObject.add(screengeometrymesh);		
		
		//front yellow target
		const Ftarget = new THREE.BoxGeometry(2, 90, 600);
		const Ftargetmesh = new THREE.Mesh(Ftarget, target);
		Ftargetmesh.position.set( -504, 999 , 0);
		rpsb_rackObject.add(Ftargetmesh);		
		//Rear yellow target
		const Rtarget = new THREE.BoxGeometry(2, 90, 600);
		const Rtargetmesh = new THREE.Mesh(Rtarget, target);
		Rtargetmesh.position.set( 504, 999 , 0);
		rpsb_rackObject.add(Rtargetmesh);		
		
		if (typeof param.reverse != 'undefined') rpsb_rackObject.rotateY(Math.PI);
		rpsb_rackObject.position.set(400, 50, -400);
		rpsb.add(rpsb_rackObject);	
		return rpsb;
	}

		
	
